// Base-code for OpenGL originally created By Tom Stanis / Jeff Molofee 2000
// .ply reading/writing adapated from Greg Turk's code by Antonio Haro 2001
// All further modifications by GJBrostow, 2002

#include <windows.h>		// Header File For Windows
#include <stdio.h>			// Header File For Standard Input/Output
#include <gl\gl.h>			// Header File For The OpenGL32 Library
#include <gl\glu.h>			// Header File For The GLu32 Library
#include <gl\glaux.h>		// Header File For The Glaux Library

#include <iostream>  //adv 6/13 to print using cout?

//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$	// GJB
#include <math.h>
#include <vector>
#include "defines.h"
#include "main.h"
#include "ply\plyMesh.h"
CPlyMesh* pPlyMesh = NULL;
std::vector<GLuint> callLstVector;

//#include <vcclr.h> //this is by ADV, i thikn for system namespace

float bbMaxX;
float bbMinX;
float bbMaxY;
float bbMinY;
float bbMaxZ;
float bbMinZ;

//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$	// GJB


HDC			hDC=NULL;		// Private GDI Device Context
HGLRC		hRC=NULL;		// Permanent Rendering Context
HWND		hWnd=NULL;		// Holds Our Window Handle
HINSTANCE	hInstance;		// Holds The Instance Of The Application

bool	keys[256];			// Array Used For The Keyboard Routine
bool	active=TRUE;		// Window Active Flag Set To TRUE By Default
bool	fullscreen=TRUE;	// Fullscreen Flag Set To Fullscreen Mode By Default
bool	light;				// Lighting ON/OFF
bool    blend;				// Blending OFF/ON? ( NEW )
bool	lp;					// L Pressed?
bool	fp;					// F Pressed?
bool	bp;					// B Pressed? ( NEW )

GLfloat	xrot;				// X Rotation
GLfloat	yrot;				// Y Rotation
GLfloat xspeed;				// X Rotation Speed
GLfloat yspeed;				// Y Rotation Speed
GLfloat	z=-5.0f;			// Depth Into The Screen

GLfloat LightAmbient[]=		{ 0.5f, 0.5f, 0.5f, 1.0f };
GLfloat LightDiffuse[]=		{ 1.0f, 1.0f, 1.0f, 1.0f };
GLfloat LightPosition[]=	{ 0.0f, 0.0f, 2.0f, 1.0f };

GLuint	filter;				// Which Filter To Use
GLuint	texture[3];			// Storage For 3 Textures

extern bool bDsplyNormalsMode;
extern bool bDsplyFlatMode;
extern bool bDsplyTextureMode;

char InPlyFileName[300];

//adv pointers to the max and min verticies
sVertex * maxZVertex;
sVertex * minZVertex;
sVertex * maxYVertex;
sVertex * minXVertex;

sVertex * minYVertex;
sVertex * maxXVertex;
//adv number of max and mins- to increse later
extern int maxStart;
extern int maxEnd;

int numOfExtremum = 4;

//this is for picking adv
int bunHits = 0;
int	mouse_x, mouse_y;	// The Current Position Of The Mouse

//added by adv on 6/1 from flowply
float avg_diffusion;
extern int diffusion_iterations;
extern float diffusion_threshold;


extern sVertex* start_times;
extern sVertex* end_times; 

GLuint vectorTexture[2]; //adv vector texture
int WINDOW_WIDTH;
int WINDOW_HEIGHT;
char * imageOfVectorField;
GLdouble projectionMatrix[16];
GLdouble modelviewMatrix[16];
GLint * viewportStuff = (GLint *)calloc(sizeof(GLint),4);

//display mode
bool bDsplyVectorFieldMode = false; //adv 6/13
int newVectorTexture = 0; //that is false
//used in makePatterns()
	int    Npat   = 32;
	int    alpha  = (0.12*255);
	#define	NPN  256 //this should be at the top was 64   128 //best was 256
   GLubyte pat[NPN][NPN][4];
   int iframe=0;

//used in draw vector fields
		#define NPIX  512 //added 6/10 this should go at the top
#define SCALE 4.0
float  tmax   = NPIX/(SCALE*NPN);

//adv trying to initialize a log file 6/13
		FILE* logfile; //adv


//adv to find x,y,z values- i was trying to use this for picking, but it wasnt working
GLdouble* GetOGLPos(int x, int y)
{
	GLint viewport[4];
	GLdouble modelview[16];
	GLdouble projection[16];
	GLfloat winX, winY, winZ;
	GLdouble posX, posY, posZ;

	glGetDoublev( GL_MODELVIEW_MATRIX, modelview );
	glGetDoublev( GL_PROJECTION_MATRIX, projection );
	glGetIntegerv( GL_VIEWPORT, viewport );

	winX = (float)x;
	winY = (float)viewport[3] - (float)y;
	glReadPixels( x, int(winY), 1, 1, GL_DEPTH_COMPONENT, GL_FLOAT, &winZ );

	gluUnProject( winX, winY, winZ, modelview, projection, viewport, &posX, &posY, &posZ);
	GLdouble * truePosition = (GLdouble * )malloc(sizeof(GLdouble)*3); //adv i think memory was made for these already, so i need to do this differentyl adv
	truePosition[0] = posX;
	truePosition[1] = posY;
	truePosition[2] = posZ;

//	float truePosition[3] = [posX, posY, posZ];

	return truePosition; //CVector3(posX, posY, posZ);
}

void Dolph()
{
//	glInitNames();												// Initializes The Name Stack
//	glPushName(0);
	//two above this added by adv	
	
//removed by quynh 6/15 	glTranslatef( -compensateX, -compensateY, -compensateZ );
		// For each face (i), plot each of the [] vertices:
		unsigned int cFaces = pPlyMesh->m_iNumFaces;
		unsigned int i = 0;

			glBegin(GL_TRIANGLES );
				while( i<cFaces && pPlyMesh->m_pFaceList[i]->ucNumVerts == 3 ) 
				{
					glPushName(i); //added by adv
					//glLoadName(i); //i is the face number?
					glVertex3f(pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[0]]->fx, pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[0]]->fy, pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[0]]->fz);

					glVertex3f(pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[1]]->fx, pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[1]]->fy, pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[1]]->fz);
					glVertex3f(pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[2]]->fx, pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[2]]->fy, pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[2]]->fz);
				
					i++;
				}
			glEnd(); // GL_TRIANGLES	

}

//added 6/10 this method is to put noise in
//call makepatters after initgl()
//make a huge rectangle, but only render and blend, where the z buffer is smaller (blend with this function?)
void makePatterns(void) 
{ 
   int lut[256];
   int phase[NPN][NPN];

   int i, j, k, t;
    
   for (i = 0; i < 256; i++) lut[i] = i < 127 ? 0 : 255;
   for (i = 0; i < NPN; i++)
   for (j = 0; j < NPN; j++) phase[i][j] = rand() % 1024;//64, 128, ---256---, 512, 1024  //maybe try to change this and see what happens (changes the frequency) 

   for (k = 0; k < Npat; k++) {
      t = k*256/Npat;
      for (i = 0; i < NPN; i++) 
      for (j = 0; j < NPN; j++) {
          pat[i][j][0] =
          pat[i][j][1] =
          pat[i][j][2] = lut[(t + phase[i][j]) % 255];
          pat[i][j][3] = alpha;
      }
      glNewList(k + 1, GL_COMPILE);
      glTexImage2D(GL_TEXTURE_2D, 0, 4, NPN, NPN, 0, GL_RGBA, GL_UNSIGNED_BYTE, pat);
      glEndList();
   }
}

void createVectorTexture(void)
{
			float deltaT = .03;
		//so use a flag- if i havent done this computation yet, then call the method
//put this in a seperate function (because it does not need to be called every time) and you can call it before you create the texture adv
		for( int numProjVert=0; numProjVert<pPlyMesh->m_iNumVertices; numProjVert++)
		{
			//pPlyMesh->m_pVertexList this hold all info of each veterx; so fx,fy,fz and tx,ty,tz, and choose a delta t, like .1
			//so v sub i times delta t first
			GLdouble * tempTanTime = (GLdouble *)calloc(sizeof(GLdouble),4);
			tempTanTime[0] = pPlyMesh->m_pVertexList[numProjVert]->fx - (pPlyMesh->m_pVertexList[numProjVert]->tx * deltaT);
			tempTanTime[1] = pPlyMesh->m_pVertexList[numProjVert]->fy - (pPlyMesh->m_pVertexList[numProjVert]->ty * deltaT);
			tempTanTime[2] = pPlyMesh->m_pVertexList[numProjVert]->fz - (pPlyMesh->m_pVertexList[numProjVert]->tz * deltaT);
			tempTanTime[3] = 1;

			GLdouble winx;  GLdouble winy; GLdouble winz;
			glGetDoublev(GL_MODELVIEW_MATRIX,modelviewMatrix);
			glGetDoublev(GL_PROJECTION_MATRIX,projectionMatrix);
			glGetIntegerv(GL_VIEWPORT,viewportStuff);

			gluProject(tempTanTime[0],tempTanTime[1],tempTanTime[2],modelviewMatrix,projectionMatrix,viewportStuff,&winx,&winy,&winz);

			//here i want to multiply an actual 4 by 4 matrix and store it in a one dimensional array that is representative of a 4 by 4 matrix?
		//	float * tempVector = (float *)calloc(sizeof(float),4);

		//	MatVecMul4Part2(projectionMatrix, tempTanTime, tempVector); //dont need this anymore

			//divide by max width and height to normalize!!! adv
			pPlyMesh->m_pVertexList[numProjVert]->vtx = (float)winx/(float)WINDOW_WIDTH;
			pPlyMesh->m_pVertexList[numProjVert]->vty = (float)winy/(float)WINDOW_HEIGHT;
			pPlyMesh->m_pVertexList[numProjVert]->vtz = (float)winz;

			pPlyMesh->m_pVertexList[numProjVert]->s = (float)winx/(float)WINDOW_WIDTH;
			pPlyMesh->m_pVertexList[numProjVert]->t = (float)winy/(float)WINDOW_HEIGHT;

			//adv trying to print to log file 6/13
/*			 fprintf (logfile, "(s,t): %f %f\n", winx, winy); 
			 fprintf (logfile, "changed: (s,t): %f %f\n", pPlyMesh->m_pVertexList[numProjVert]->vtx, pPlyMesh->m_pVertexList[numProjVert]->vty); 
			fflush(logfile); 
*/
		}
}


void DrawVectorField()
{
//works really well when it's loop<1
 for(int loop=0; loop<1; loop++)
{
	//Step 2: Initialize the image F with B (F will eventually be shown on the screen- so clear actual screen)
		glClearColor(0.5,0.5,0.5,1); //.6 might be better 
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	//step 3: calculate texture coordinates: t sub i = T(r sub i - v sub i * delta t) ... so this will lead to 2D texture coordinates
		//in order to perform this transformation we need to get the projection matrix and multiply it by ... by what?... we're using the projected position of the previous point on the path line through the vertex r sub i
	////		glMatrixMode(GL_PROJECTION);.... get the projection matrix .... glGetFloatv(GL_PROJECTION_MATRIX, projectionMatrix);

	//step 3 used to be here!
		
	//Step 4: render the mesh with this as a texture
		unsigned int cFaces = pPlyMesh->m_iNumFaces;
		//maybe bind th etexture here adv
			//enable texture here!!!!

		glEnable(GL_TEXTURE_2D);
		glBindTexture(GL_TEXTURE_2D, vectorTexture[0]); //ok so it's rather weird 6/15 //   texture[0]
		glBegin(GL_TRIANGLES );
		unsigned int i=0;
		while( i<cFaces && pPlyMesh->m_pFaceList[i]->ucNumVerts == 3 ) 
		{
			glTexCoord2f( pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[0]]->vtx, pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[0]]->vty);
			glVertex3f(pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[0]]->fx, pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[0]]->fy, pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[0]]->fz);

			glTexCoord2f( pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[1]]->vtx, pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[1]]->vty);
			glVertex3f(pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[1]]->fx, pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[1]]->fy, pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[1]]->fz);

			glTexCoord2f( pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[2]]->vtx, pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[2]]->vty);
			glVertex3f(pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[2]]->fx, pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[2]]->fy, pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[2]]->fz);
				
			i++;
		}
			glEnd(); // GL_TRIANGLES

		glDisable(GL_TEXTURE_2D);

		iframe = iframe + 1;

		//step 5 ... blend with the noise

	//glColor3f(1,0,1); //adv test majenta
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glLoadIdentity();

	//adv 6/14 added from sample code
	//due to call list, i dont need this name at all		glBindTexture(GL_TEXTURE_2D, vectorTexture[1]);//texture[0]
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND); 
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA); 
		glDepthFunc(GL_GREATER); //if the rectangle is further away than the stuff that's there, blend it?
		
		glCallList(iframe % Npat + 1);
	//	glBindTexture(GL_TEXTURE_2D, texture[0]);//

		glBegin(GL_QUADS);
			glTexCoord2f(0.0,  0.0);  glVertex3f(-60, -50, -95);
			glTexCoord2f(0.0,  tmax); glVertex3f(60, -50, -95);
			glTexCoord2f(tmax, 0.0);  glVertex3f(60, 50, -95);
			glTexCoord2f(tmax, tmax); glVertex3f(-60, 50, -95);
		glEnd();
		glBindTexture(GL_TEXTURE_2D, vectorTexture[0]);//texture[0]
//		glCopyTexSubImage2D(GL_TEXTURE_2D, 0, 0, 0, 0, 0, WINDOW_WIDTH, WINDOW_HEIGHT); //is this for the loop and motion? //was third when not sub , GL_RGB; border was last , 0
		glCopyTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, 0, 0, WINDOW_WIDTH, WINDOW_HEIGHT, 0);
		glDisable(GL_BLEND);
		glDepthFunc(GL_LESS);

		glDisable(GL_TEXTURE_2D);

	glPopMatrix();
	

//adv blend it with the shaded model now try alpha of .4 or .5
		glEnable(GL_LIGHTING);  //lighting makes the color go away, the other texture has lighting disabled
		glEnable(GL_LIGHT0);
		glEnable(GL_LIGHT1);
		glShadeModel( GL_SMOOTH);
		glColor4f(1.0, 1.0, 1.0, 0.5);

//		glEnable(GL_BLEND); 
//		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA); 

		glEnable(GL_TEXTURE_2D);
		glBindTexture(GL_TEXTURE_2D, vectorTexture[0]); //ok so it's rather weird 6/15 //  texture[0] 
		glBegin(GL_TRIANGLES );
		unsigned int f=0;
		while( f<cFaces && pPlyMesh->m_pFaceList[f]->ucNumVerts == 3 ) 
		{
			glNormal3f(pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[f]->pi_verts[0]]->fnx,pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[f]->pi_verts[0]]->fny,pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[f]->pi_verts[0]]->fnz);
			glTexCoord2f( pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[f]->pi_verts[0]]->vtx, pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[f]->pi_verts[0]]->vty);
			glVertex3f(pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[f]->pi_verts[0]]->fx, pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[f]->pi_verts[0]]->fy, pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[f]->pi_verts[0]]->fz);

			glNormal3f(pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[f]->pi_verts[1]]->fnx, pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[f]->pi_verts[1]]->fny, pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[f]->pi_verts[1]]->fnz);
			glTexCoord2f( pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[f]->pi_verts[1]]->vtx, pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[f]->pi_verts[1]]->vty);
			glVertex3f(pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[f]->pi_verts[1]]->fx, pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[f]->pi_verts[1]]->fy, pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[f]->pi_verts[1]]->fz);

			glNormal3f(pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[f]->pi_verts[2]]->fnx, pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[f]->pi_verts[2]]->fny, pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[f]->pi_verts[2]]->fnz);
			glTexCoord2f( pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[f]->pi_verts[2]]->vtx, pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[f]->pi_verts[2]]->vty);
			glVertex3f(pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[f]->pi_verts[2]]->fx, pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[f]->pi_verts[2]]->fy, pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[f]->pi_verts[2]]->fz);
				
			f++;
		}
			glEnd(); // GL_TRIANGLES

		glDisable(GL_TEXTURE_2D);
//		glDisable(GL_BLEND);

		glDisable(GL_LIGHTING);

		
}//end loop

}

//adv method for picking - not working correctly right now
void Selection(void)											// This Is Where Selection Is Done
{

//ok the problem is "hits" vs. bunHits .. if i click on the dolphin 5 times, bunHits will be 5, BUT "hits" means how many points we're hitting at
	//one particular time, which in all likelyhood will be one, which is fine, however, I want to keep track of the value of each one by placing them
	// as they come into start and end arrays

	GLuint	buffer[512];										// Set Up A Selection Buffer
	GLint	hits;												// The Number Of Objects That We Selected

	// The Size Of The Viewport. [0] Is <x>, [1] Is <y>, [2] Is <length>, [3] Is <width>
	GLint	viewport[4];

	// This Sets The Array <viewport> To The Size And Location Of The Screen Relative To The Window
	glGetIntegerv(GL_VIEWPORT, viewport);  //advt
	glSelectBuffer(512, buffer);								// Tell OpenGL To Use Our Array For Selection

	// Puts OpenGL In Selection Mode. Nothing Will Be Drawn.  Object ID's and Extents Are Stored In The Buffer.
	(void) glRenderMode(GL_SELECT); 


 	glInitNames();												// Initializes The Name Stack //adv  these two used to be in two places ... 6.24  are they still?
	glPushName(0);												// Push 0 (At Least One Entry) Onto The Stack

	glMatrixMode(GL_PROJECTION);								// Selects The Projection Matrix
	glPushMatrix();												// Push The Projection Matrix
	glLoadIdentity();											// Resets The Matrix

	// This Creates A Matrix That Will Zoom Up To A Small Portion Of The Screen, Where The Mouse Is.
	gluPickMatrix((GLdouble) mouse_x, (GLdouble) (viewport[3]-mouse_y), 1.0f, 1.0f, viewport);

	// Apply The Perspective Matrix
	gluPerspective(45.0f, (GLfloat) (viewport[2]-viewport[0])/(GLfloat) (viewport[3]-viewport[1]), 0.1f, 100.0f);
	
	glMatrixMode(GL_MODELVIEW);									// Select The Modelview Matrix
//n- but do i need to draw dolphin here? DrawTargets(); // Render The Targets To The Selection Buffer
//	glLoadName(0);	//I only have one object- so i'm puting it in the first place of the name thing? adv
//	InvalidateRect(hWnd, NULL, NULL ); //added by adv to redraw the dolphin
	Dolph(); //adv added this back on 6.24
//	glCallList(callLstVector[0]);
	float depthOfStack; 
	glGetFloatv( GL_NAME_STACK_DEPTH, &depthOfStack);
	fprintf (logfile, "depth: %f\n", depthOfStack); 
			fflush(logfile); 


	glMatrixMode(GL_PROJECTION);								// Select The Projection Matrix
	glPopMatrix();												// Pop The Projection Matrix
	glMatrixMode(GL_MODELVIEW);									// Select The Modelview Matrix
	hits=glRenderMode(GL_RENDER);								// Switch To Render Mode, Find Out How Many
											// Objects Were Drawn Where The Mouse Was
	if (hits > 0)												// If There Were More Than 0 Hits
	{
		//choose is always zero -- the last spot is supposed to be the name of the thing on the stack, but our stack always only has one thing- so it's 0, BUT now how, do we get the number it's pointing to?
		int	choose = buffer[3];									// Make Our Selection The First Object
		int depth = buffer[1];									// Store How Far Away It Is 

	//		GLdouble* currentPosition = GetOGLPos(mouse_x,mouse_y);
	//	bunHits = currentPosition[2];

	bunHits++;

		
		for (int loop = 1; loop < hits; loop++)					// Loop Through All The Detected Hits --adv i'm refferring to verticies now
		{
			// If This Object Is Closer To Us Than The One We Have Selected -check if it's closest, only if it has a different name(maybe)
			if (buffer[loop*4+1] < GLuint(depth))
			{
				choose = buffer[loop*4+3];						// Select The Closer Object
				depth = buffer[loop*4+1];						// Store How Far Away It Is
			}       
		}

		//set the vertex that 'choose' holds equal to start or end, based on some variable: 
		if(bunHits<maxStart || bunHits==maxStart)
		{
//			start_times[bunHits-1] = *pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[10]->pi_verts[1]]; //choose
		}
		else if(bunHits==maxStart+1)
		{
//			end_times[0] = *pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[32]->pi_verts[1]]; //choose
		}
    }
}

// Font & print to screen section
//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
GLuint	base;				// Base Display List For The Font Set
GLvoid BuildFont(GLvoid)								// Build Our Bitmap Font
{
	HFONT	font;										// Windows Font ID
	HFONT	oldfont;									// Used For Good House Keeping

	base = glGenLists(96);								// Storage For 96 Characters

	font = CreateFont(	-14,							// Height Of Font // Def: -24
						0,								// Width Of Font
						0,								// Angle Of Escapement
						0,								// Orientation Angle
						FW_SEMIBOLD,						// Font Weight // Def: FW_BOLD
						FALSE,							// Italic
						FALSE,							// Underline
						FALSE,							// Strikeout
						ANSI_CHARSET,					// Character Set Identifier
						OUT_TT_PRECIS,					// Output Precision
						CLIP_DEFAULT_PRECIS,			// Clipping Precision
						ANTIALIASED_QUALITY,			// Output Quality
						FF_DONTCARE|DEFAULT_PITCH,		// Family And Pitch
						"Lucida Console");					// Font Name. Def:"Courier New" // Century Gothic// Lucida Console//Verdana

	oldfont = (HFONT)SelectObject(hDC, font);           // Selects The Font We Want
	wglUseFontBitmaps(hDC, 32, 96, base);				// Builds 96 Characters Starting At Character 32
	SelectObject(hDC, oldfont);							// Selects The Font We Want
	DeleteObject(font);									// Delete The Font
}

GLvoid KillFont(GLvoid)									// Delete The Font List
{
	glDeleteLists(base, 96);							// Delete All 96 Characters
}
//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

//***************** Loading Texture ********************//

AUX_RGBImageRec *LoadBMP(char *Filename)				// Loads A Bitmap Image
{
	FILE *File=NULL;									// File Handle

	if (!Filename)										// Make Sure A Filename Was Given
	{
		return NULL;									// If Not Return NULL
	}

	File=fopen(Filename,"r");							// Check To See If The File Exists

	if (File)											// Does The File Exist?
	{
		fclose(File);									// Close The Handle
		return auxDIBImageLoad(Filename);				// Load The Bitmap And Return A Pointer
	}

	return NULL;										// If Load Failed Return NULL
}

int LoadGLTextures()									// Load Bitmaps And Convert To Textures
{
	int Status=FALSE;									// Status Indicator

	AUX_RGBImageRec *TextureImage[1];					// Create Storage Space For The Texture

	memset(TextureImage,0,sizeof(void *)*1);           	// Set The Pointer To NULL

	// Load The Bitmap, Check For Errors, If Bitmap's Not Found Quit
	if (TextureImage[0]=LoadBMP("Data/checkerboard512.bmp"))
	{
		Status=TRUE;									// Set The Status To TRUE

		glGenTextures(3, &texture[0]);					// Create Three Textures

		// Create Nearest Filtered Texture
		glBindTexture(GL_TEXTURE_2D, texture[0]);//vectorTexture[0] -- when I put either of my textures here it is blank 6/15
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
		glTexImage2D(GL_TEXTURE_2D, 0, 3, TextureImage[0]->sizeX, TextureImage[0]->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[0]->data);

		// Create Linear Filtered Texture
		glBindTexture(GL_TEXTURE_2D, texture[1]);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
		glTexImage2D(GL_TEXTURE_2D, 0, 3, TextureImage[0]->sizeX, TextureImage[0]->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[0]->data);

		// Create MipMapped Texture
		glBindTexture(GL_TEXTURE_2D, texture[2]);
		//glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
		//glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_NEAREST);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR_MIPMAP_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_LINEAR);

		gluBuild2DMipmaps(GL_TEXTURE_2D, 3, TextureImage[0]->sizeX, TextureImage[0]->sizeY, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[0]->data);
	}

	if (TextureImage[0])								// If Texture Exists
	{
		if (TextureImage[0]->data)						// If Texture Image Exists
		{
			free(TextureImage[0]->data);				// Free The Texture Image Memory
		}

		free(TextureImage[0]);							// Free The Image Structure
	}

	return Status;										// Return The Status
}

//***************** Calculating Face Normal ********************//
void CalcFaceNormal( GLfloat* a, GLfloat* b, GLfloat* c, GLfloat* normal ) {
	float ab[3];
	float bc[3];
	VecSub(b, a, ab);	// b-a = Vector a_to_b;
	VecSub(c, b, bc);

	int ans;

	glGetIntegerv( GL_FRONT_FACE, &ans );
	if(  ans == GL_CCW ) {
		VecCross(ab, bc, normal); // Correct
	}
	else {
		VecCross(bc, ab, normal); // Wrong, but like viewply.
	}
	VecNormalize(normal);
	return;
}

//***************** Creating Call Lists ********************//
// Returns the # of CallListItems that were successfully removed.
// num == the # of CallListItems you wish to drop from the end of the list.
int RemLastCallListItems( int num ) {
	std::vector<GLuint>::iterator callLstVectIt = callLstVector.end();
	
	for( int i=0; i < num; i++ ) {
		callLstVectIt--;
		glDeleteLists( *callLstVectIt, 1 );
		callLstVector.erase( callLstVectIt );
	}

	return( i );
}

void CalcPlyBoundingBox() {
	float x=0.f, y=0.f, z=0.f;
	bbMaxX = -100000.f;
	bbMinX = 100000.f;
	bbMaxY = -100000.f;
	bbMinY = 100000.f;
	bbMaxZ = -100000.f;
	bbMinZ = 100000.f;

	for( int i=0; i < pPlyMesh->m_iNumVertices; i++ ) {
		x = pPlyMesh->m_pVertexList[i]->fx;
		y = pPlyMesh->m_pVertexList[i]->fy;
		z = pPlyMesh->m_pVertexList[i]->fz;
		if( x > bbMaxX ) bbMaxX = x;
		if( x < bbMinX ) bbMinX = x;
		if( y > bbMaxY ) bbMaxY = y;
		if( y < bbMinY ) bbMinY = y;
		if( z > bbMaxZ ) bbMaxZ = z;
		if( z < bbMinZ ) bbMinZ = z;
	}

}


void AddPlyMeshToCallList() {
	unsigned int i;
	// Load plyMesh's vertices into GLfloat[3] arrays for rendering:
	std::vector<GLfloat*> VerticesVect;

//adv top four used for dolphin

	maxZVertex = pPlyMesh->m_pVertexList[0]; //maximum z direction
	minZVertex = pPlyMesh->m_pVertexList[0]; //minumum z direction
	maxYVertex = pPlyMesh->m_pVertexList[0]; //maximum y direction
	minXVertex = pPlyMesh->m_pVertexList[0]; //minimum x direction

	minYVertex = pPlyMesh->m_pVertexList[0]; // minimum y direction
	maxXVertex = pPlyMesh->m_pVertexList[0]; //maximum x direction

	for( i=0; i < pPlyMesh->m_iNumVertices; i++ ) {
		GLfloat* tmpFloat3Arr = new(GLfloat[3]);
		tmpFloat3Arr[0] = pPlyMesh->m_pVertexList[i]->fx;
		tmpFloat3Arr[1] = pPlyMesh->m_pVertexList[i]->fy;
		tmpFloat3Arr[2] = pPlyMesh->m_pVertexList[i]->fz;

		//adv
		float tempVertexMaxZ = max(maxZVertex->fz,pPlyMesh->m_pVertexList[i]->fz);
		float tempVertexMinZ = min(minZVertex->fz,pPlyMesh->m_pVertexList[i]->fz);
		float tempVertexMaxY = max(maxYVertex->fy,pPlyMesh->m_pVertexList[i]->fy);
		float tempVertexMinX = min(minXVertex->fx,pPlyMesh->m_pVertexList[i]->fx);

		float tempVertexMinY = min(minYVertex->fy,pPlyMesh->m_pVertexList[i]->fy);
		float tempVertexMaxX = max(maxXVertex->fx,pPlyMesh->m_pVertexList[i]->fx);
		if(tempVertexMaxZ == pPlyMesh->m_pVertexList[i]->fz)
		{
			maxZVertex = pPlyMesh->m_pVertexList[i];
		}
		else
			if(tempVertexMinZ == pPlyMesh->m_pVertexList[i]->fz)
			{
				minZVertex = pPlyMesh->m_pVertexList[i];
			}

		if(tempVertexMaxY == pPlyMesh->m_pVertexList[i]->fy)
		{
            maxYVertex = pPlyMesh->m_pVertexList[i];
		}
		else
			if(tempVertexMinY == pPlyMesh->m_pVertexList[i]->fy)
			{
				minYVertex = pPlyMesh->m_pVertexList[i];
			}
		if(tempVertexMinX == pPlyMesh->m_pVertexList[i]->fx)
		{
			minXVertex = pPlyMesh->m_pVertexList[i];
		}
		else
			if(tempVertexMaxX == pPlyMesh->m_pVertexList[i]->fx)
			{
				maxXVertex = pPlyMesh->m_pVertexList[i];
			}


		VerticesVect.push_back( tmpFloat3Arr );
	}
 
//ADV dont need these if i use PICKING
	//ADV this is where I changed teh values of teh sources and sinks- I used min and max of X, Y or Z

/*	start_times[0] = *minZVertex;    ///this was start_times[0] whatever
  	end_times[1] = *maxYVertex;  /////this was start_times[1] whatever
	start_times[1]  = *minXVertex;  /////this was start_times[2] whatever
	end_times[0] = *maxZVertex; /////this was  end_times[0] whatever
*/

	start_times[0] = *minXVertex;
	end_times[0] = *maxXVertex;
	//I did not end up using this part
//adv	start_times[0].marked = START_BOUNDARY;
//adv	start_times[1].marked = START_BOUNDARY;
//adv	end_times[0].marked = END_BOUNDARY;

	callLstVector.push_back( glGenLists(1) );

	float compensateX = (bbMaxX + bbMinX)/2;
	float compensateY = (bbMaxY + bbMinY)/2;
	float compensateZ = (bbMaxZ + bbMinZ)/2;

	GLfloat normal3d[3];
	glNewList(callLstVector[0],GL_COMPILE);

	glInitNames();												// Initializes The Name Stack
	glPushName(0);
	//two above this added by adv	
	
//removed by quynh 6/15 	glTranslatef( -compensateX, -compensateY, -compensateZ );
		// For each face (i), plot each of the [] vertices:
		unsigned int cFaces = pPlyMesh->m_iNumFaces;
		for( i=0; i<cFaces;  ) {

			// Texture Mode
			if ( bDsplyTextureMode) {
				glEnable (GL_TEXTURE_2D);
				glBindTexture(GL_TEXTURE_2D, texture[0]);
				glColor3f (1.0f, 1.0f, 1.0f);
			}

			glBegin(GL_TRIANGLES );
				while( i<cFaces && pPlyMesh->m_pFaceList[i]->ucNumVerts == 3 ) {
					if( bDsplyNormalsMode || bDsplyFlatMode || bDsplyTextureMode ) { //adv tried adding || bDsplyVectorFieldMode 6/13
						CalcFaceNormal( VerticesVect[	pPlyMesh->m_pFaceList[i]->pi_verts[0]	],
										VerticesVect[	pPlyMesh->m_pFaceList[i]->pi_verts[1]	],
										VerticesVect[	pPlyMesh->m_pFaceList[i]->pi_verts[2]	],
										normal3d );
						glNormal3fv( normal3d );
					}
					if( bDsplyNormalsMode ) {
						glColor3f(fabs(normal3d[0]), fabs(normal3d[1]), fabs(normal3d[2])); // For GEOMMENU
					}

					if ( bDsplyTextureMode) { // Texture Mode
						glTexCoord2f( pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[0]]->s,
									 pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[0]]->t);
						glVertex3fv( VerticesVect[	pPlyMesh->m_pFaceList[i]->pi_verts[0]	] );
						
						glTexCoord2f( pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[1]]->s,
									 pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[1]]->t);
						glVertex3fv( VerticesVect[	pPlyMesh->m_pFaceList[i]->pi_verts[1]	] );
						
						glTexCoord2f( pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[2]]->s,
									 pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[2]]->t);
						glVertex3fv( VerticesVect[	pPlyMesh->m_pFaceList[i]->pi_verts[2]	] );
					}
					//tried putting an else vectorfieldMode thing here...
					else {

						glPushName(i); //added by adv
						glVertex3fv( VerticesVect[	pPlyMesh->m_pFaceList[i]->pi_verts[0]	] );
						glVertex3fv( VerticesVect[	pPlyMesh->m_pFaceList[i]->pi_verts[1]	] );
						glVertex3fv( VerticesVect[	pPlyMesh->m_pFaceList[i]->pi_verts[2]	] );
					}
					i++;
				}
			glEnd(); // GL_TRIANGLES
			glBegin(GL_QUADS);
				while( i<cFaces && pPlyMesh->m_pFaceList[i]->ucNumVerts == 4 ) {
					if( bDsplyNormalsMode || bDsplyFlatMode || bDsplyTextureMode) {
						CalcFaceNormal( VerticesVect[	pPlyMesh->m_pFaceList[i]->pi_verts[0]	],
										VerticesVect[	pPlyMesh->m_pFaceList[i]->pi_verts[1]	],
										VerticesVect[	pPlyMesh->m_pFaceList[i]->pi_verts[2]	],
										normal3d );
						glNormal3fv( normal3d );
					}
					if( bDsplyNormalsMode ) {
						glColor3f(fabs(normal3d[0]), fabs(normal3d[1]), fabs(normal3d[2])); // For GEOMMENU
					}
					if ( bDsplyTextureMode) { // Texture Mode
						glTexCoord2f( pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[0]]->s,
									 pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[0]]->t);
						glVertex3fv( VerticesVect[	pPlyMesh->m_pFaceList[i]->pi_verts[0]	] );

						glTexCoord2f( pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[1]]->s,
									 pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[1]]->t);
						glVertex3fv( VerticesVect[	pPlyMesh->m_pFaceList[i]->pi_verts[1]	] );
						
						glTexCoord2f( pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[2]]->s,
									 pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[2]]->t);
						glVertex3fv( VerticesVect[	pPlyMesh->m_pFaceList[i]->pi_verts[2]	] );
						
						glTexCoord2f( pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[3]]->s,
									 pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[3]]->t);
						glVertex3fv( VerticesVect[	pPlyMesh->m_pFaceList[i]->pi_verts[3]	] );
					}
					else {
						glVertex3fv( VerticesVect[	pPlyMesh->m_pFaceList[i]->pi_verts[0]	] );
						glVertex3fv( VerticesVect[	pPlyMesh->m_pFaceList[i]->pi_verts[1]	] );
						glVertex3fv( VerticesVect[	pPlyMesh->m_pFaceList[i]->pi_verts[2]	] );
						glVertex3fv( VerticesVect[	pPlyMesh->m_pFaceList[i]->pi_verts[3]	] );
					}
					i++;
				}
			glEnd(); // GL_QUADS
			while( i<cFaces && pPlyMesh->m_pFaceList[i]->ucNumVerts > 4 ) {
				glBegin(GL_POLYGON);
					if( bDsplyNormalsMode || bDsplyFlatMode || bDsplyTextureMode) {
						CalcFaceNormal( VerticesVect[	pPlyMesh->m_pFaceList[i]->pi_verts[0]	],
										VerticesVect[	pPlyMesh->m_pFaceList[i]->pi_verts[1]	],
										VerticesVect[	pPlyMesh->m_pFaceList[i]->pi_verts[2]	],
										normal3d );
						glNormal3fv( normal3d );
					}
					if( bDsplyNormalsMode ) {
						glColor3f(fabs(normal3d[0]), fabs(normal3d[1]), fabs(normal3d[2])); // For GEOMMENU
					}
					for( int j=0; j < pPlyMesh->m_pFaceList[i]->ucNumVerts; j++ ) {
						if ( bDsplyTextureMode) // Texture Mode
							glTexCoord2f( pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[j]]->s,
										 pPlyMesh->m_pVertexList[pPlyMesh->m_pFaceList[i]->pi_verts[j]]->t);
						glVertex3fv( VerticesVect[	pPlyMesh->m_pFaceList[i]->pi_verts[j]	] );
					}
					i++;
				glEnd(); // GL_POLYGON
			}
			
			// Texture Mode
			if ( bDsplyTextureMode) glDisable(GL_TEXTURE_2D);
		}

			//adv test to draw vector field
			glColor3f(0,0,1);
			glBegin(GL_LINES);
			//i should really just iterate throught the list of verticies, and print out a line starting at each vertex, and 
			//going a short distince in teh direction of normal, and tangent
			for( i=0; i < pPlyMesh->m_iNumVertices; i++ ) {
				glVertex3f(pPlyMesh->m_pVertexList[i]->fx, pPlyMesh->m_pVertexList[i]->fy, pPlyMesh->m_pVertexList[i]->fz);
				//glVertex3f(pPlyMesh->m_pVertexList[i]->fx+(pPlyMesh->m_pVertexList[i]->fnx/10), pPlyMesh->m_pVertexList[i]->fy+(pPlyMesh->m_pVertexList[i]->fny/10), pPlyMesh->m_pVertexList[i]->fz+(pPlyMesh->m_pVertexList[i]->fnz/10));
				glVertex3f(pPlyMesh->m_pVertexList[i]->fx+(pPlyMesh->m_pVertexList[i]->tx/20), pPlyMesh->m_pVertexList[i]->fy+(pPlyMesh->m_pVertexList[i]->ty/20), pPlyMesh->m_pVertexList[i]->fz+(pPlyMesh->m_pVertexList[i]->tz/20));
               // glVertex3f(pPlyMesh->m_pVertexList[i]->fx+(pPlyMesh->m_pVertexList[i]->gradx), pPlyMesh->m_pVertexList[i]->fy+(pPlyMesh->m_pVertexList[i]->grady), pPlyMesh->m_pVertexList[i]->fz+(pPlyMesh->m_pVertexList[i]->gradz));

				//make an arrow for the tangents
	/*			glVertex3f(pPlyMesh->m_pVertexList[i]->fx+(pPlyMesh->m_pVertexList[i]->tx/10), pPlyMesh->m_pVertexList[i]->fy+(pPlyMesh->m_pVertexList[i]->ty/10), pPlyMesh->m_pVertexList[i]->fz+(pPlyMesh->m_pVertexList[i]->tz/10));
				glVertex3f(pPlyMesh->m_pVertexList[i]->fx+(pPlyMesh->m_pVertexList[i]->tx/10)+.005, pPlyMesh->m_pVertexList[i]->fy+(pPlyMesh->m_pVertexList[i]->ty/10)+.005, pPlyMesh->m_pVertexList[i]->fz+(pPlyMesh->m_pVertexList[i]->tz/10)-.005);

				glVertex3f(pPlyMesh->m_pVertexList[i]->fx+(pPlyMesh->m_pVertexList[i]->tx/10), pPlyMesh->m_pVertexList[i]->fy+(pPlyMesh->m_pVertexList[i]->ty/10), pPlyMesh->m_pVertexList[i]->fz+(pPlyMesh->m_pVertexList[i]->tz/10));
				glVertex3f(pPlyMesh->m_pVertexList[i]->fx+(pPlyMesh->m_pVertexList[i]->tx/10)-.005, pPlyMesh->m_pVertexList[i]->fy+(pPlyMesh->m_pVertexList[i]->ty/10)-.005, pPlyMesh->m_pVertexList[i]->fz+(pPlyMesh->m_pVertexList[i]->tz/10)-.005);
	*/		
			}
			glEnd();
			glColor3f(0,0,1);
			glColor3f (1.0f, 1.0f, 1.0f);

//removed by quynh 6/15		glTranslatef( compensateX, compensateY, compensateZ );
	glEndList();

	// Cleanup of temporary structures:
	std::vector<GLfloat*>::iterator VectIt;
	for( VectIt=VerticesVect.begin(); VectIt != VerticesVect.end(); VectIt++ ) {
		delete[] *VectIt;
	}
	VerticesVect.clear();
}

void vectorInfo(void)
{
		//added by adv 6/1 - to find adjacency info
	pPlyMesh->collect_adj_info();
	pPlyMesh->boundary_corr_init(); //to get start and end

		fprintf (logfile, "start x, y, z and end x, y, z: %f %f %f %f %f %f\n", start_times[0].fx,start_times[0].fy,start_times[0].fz, end_times[0].fx, end_times[0].fy, end_times[0].fz); 
			fflush(logfile); 


	for (int i = 0; i < diffusion_iterations; i++)  //to do geometric heat diffusion
	{
      if ((i%2) == 0) printf ("Diffusion step: %i\n", i);
         avg_diffusion = pPlyMesh->desbrun();
      if (avg_diffusion < diffusion_threshold) 
	     break;
    }
	pPlyMesh->generate_normal_field();
	pPlyMesh->generate_weighted_tangent_field();
	// adv 6/13 tried adding the vectorMode thing here


}

//***************** Initializing GL ********************//
//adv this is where it reads plyMesh
int InitGL(GLvoid)										// All Setup For OpenGL Goes Here
{
	//adv trying to open a log file ... is this the beginning?  6/13
	logfile = fopen("log.txt\0","w+"); //adv 
	makePatterns();
	WINDOW_WIDTH = WINDOW_HEIGHT = 512;
	imageOfVectorField = (char *) calloc( WINDOW_WIDTH*WINDOW_HEIGHT*3, sizeof(char) ); //GL_UNSIGNED_BYTE //
			for(int wh=0; wh<WINDOW_WIDTH*WINDOW_HEIGHT*3; wh++)  //was w and h // wh+=3
			{
                imageOfVectorField[wh] = (char)127; //(char)255; //
			}
		//Step 1: Initialize texture image F sub t (w/o shading) with background color
		glGenTextures(1, &vectorTexture[0]);					// Create The Texture
		// Typical Texture Generation Using Data From The Bitmap
		glBindTexture(GL_TEXTURE_2D, vectorTexture[0]);
		// Generate The Texture
//		glTexEnvf( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE );
		glTexImage2D(GL_TEXTURE_2D, 0, 3, WINDOW_WIDTH, WINDOW_HEIGHT, 0, GL_RGB, GL_UNSIGNED_BYTE, imageOfVectorField); //   this is not supposed to be -- the last thing is wrong-- see the nehe tutorial
		//not sure if i need these, or more parameters
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);	// Linear Filtering
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);	// Linear Filtering

	if (!LoadGLTextures())								// Jump To Texture Loading Routine
	{
		///return FALSE;									// If Texture Didn't Load Return FALSE
	}

	BuildFont();										// Build The Font

	glClearColor(0.0f, 0.7f, 0.9f, 0.0f);				// Black Background
	glClearDepth(1.0f);									// Depth Buffer Setup

	glEnable(GL_DEPTH_TEST);
	glDepthFunc(GL_LESS); // GL_LEQUAL ?

	//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$	// GJB
	pPlyMesh = new CPlyMesh(); //adv  creating new plymesh
	if( strlen( InPlyFileName ) ) {
		pPlyMesh->ReadPlyMesh( InPlyFileName ); //adv reads in the mesh
	}
	else {
		pPlyMesh->ReadPlyMesh("Data\\cube.ply");
	}

	CalcPlyBoundingBox();
	AddPlyMeshToCallList();

	vectorInfo(); //adv

	//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$	// GJB

	return TRUE;										// Initialization Went OK
}

//***************** Drawing Scene by calling Call List ********************//
int DrawGLScene(GLvoid)									// Here's Where We Do All The Drawing
{
	xrot=xspeed;	// Rotate and hold.
	yrot=yspeed;
	
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// Clear The Screen And The Depth Buffer

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
//adv mess around with these to make the dolphin look better
/*	GLfloat light_ambient0[] = { 0.3f, 0.3f, 0.3f, 1.0f };
	GLfloat light_diffuse0[] = { 0.7f, 0.7f, 0.7f, 1.0f };
	GLfloat light_specular0[] = { 0.0, 0.0, 0.0, 1.0 };
	GLfloat light_ambient1[] = { 0.0, 0.0, 0.0, 1.0 };
	GLfloat light_diffuse1[] = { 0.5, 0.5, 0.5, 1.0 };
	GLfloat light_specular1[] = { 0.0, 0.0, 0.0, 1.0 };
	GLfloat light_position[] = { 0.0, 0.0, 10.0, 1.0 };
*/

	GLfloat light_ambient0[] = { 0.7f, 0.7f, 0.7f, 1.0f }; //comes from all around
	GLfloat light_diffuse0[] = { 0.8f, 0.8f, 0.8f, 1.0f }; //bounces off to all around
	GLfloat light_specular0[] = { 0.0, 0.0, 0.0, 1.0 }; //reflects to one direction
	GLfloat light_ambient1[] = { 0.0, 0.0, 0.0, 1.0 };
	GLfloat light_diffuse1[] = { 0.5, 0.5, 0.5, 1.0 };
	GLfloat light_specular1[] = { 0.0, 0.0, 0.0, 1.0 };
	GLfloat light_position[] = { 10.0, 10.0, 10.0, 1.0 };

	glLightfv(GL_LIGHT0, GL_AMBIENT, light_ambient0);
	glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse0);
	glLightfv(GL_LIGHT0, GL_SPECULAR, light_specular0);
	glLightfv(GL_LIGHT1, GL_AMBIENT, light_ambient1);
	glLightfv(GL_LIGHT1, GL_DIFFUSE, light_diffuse1);
	glLightfv(GL_LIGHT1, GL_SPECULAR, light_specular1);

	//glOrtho(-1.01, 1.01, -1.01, 1.01, 0.0, 40.0);
	glMatrixMode(GL_MODELVIEW);

	//glLightfv(GL_LIGHT0, GL_POSITION, light_position);
/*
	light_position[0] = -0.1f;
	light_position[1] = 0.0;
	light_position[2] = 0.0;
*/
	light_position[0] = -0.1f;
	light_position[1] = -0.1;
	light_position[2] = 0.0;
	//glLightfv(GL_LIGHT1, GL_POSITION, light_position);

	RenderHeadsUpText();

	ActivatePolyModeAndLighting();
	
	glLoadIdentity();									// Reset The View

	glTranslatef(0.0f,0.0f,z);

	glRotatef(xrot,1.0f,0.0f,0.0f);
	glRotatef(yrot,0.0f,1.0f,0.0f);

  // Center model -- moved here by quynh 6/15
    float compensateX = (bbMaxX + bbMinX)/2;
    float compensateY = (bbMaxY + bbMinY)/2;
    float compensateZ = (bbMaxZ + bbMinZ)/2;
    glTranslatef( -compensateX, -compensateY, -compensateZ );

	glLightfv(GL_LIGHT0, GL_POSITION, light_position);
	//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$	// GJB

	//	To render the contents of all call lists, accumulate them into an array.
	unsigned int i=0;
	int numCallLists = callLstVector.size();
	GLuint* ListArr = (GLuint*)calloc( numCallLists, sizeof(GLuint) );
	
	for( i=0; i< numCallLists; i++ ) {
		ListArr[i] = callLstVector[i];
	}
	if(!bDsplyVectorFieldMode)
	{
	glCallLists( numCallLists, GL_UNSIGNED_INT, ListArr );
	free(ListArr);
	}

	//adv practice
//	glDisable(GL_LIGHTING);

//	glColor3f(0,0,1.0);
	glBegin(GL_LINES );
/*	glColor3f(1, 0, 0); //x r
	glVertex3f(0,0,0);
	glVertex3f(50,0,0);
	glColor3f(0, 1, 0); //y g
	glVertex3f(0,0,0);
	glVertex3f(0,50,0);
	glColor3f(0, 0, 1); //z b
	glVertex3f(0,0,0);
	glVertex3f(0,0,50);
*/
/*	glVertex3f(maxZVertex->fx,maxZVertex->fy,maxZVertex->fz);
	glVertex3f(minZVertex->fx,minZVertex->fy,minZVertex->fz);

	glVertex3f(maxYVertex->fx,maxYVertex->fy,maxYVertex->fz);
	glVertex3f(minZVertex->fx,minZVertex->fy,minZVertex->fz);

	glVertex3f(minXVertex->fx,minXVertex->fy,minXVertex->fz);
	glVertex3f(maxZVertex->fx,maxZVertex->fy,maxZVertex->fz);
*/
/////	glColor3f(1, 0, 0);
//	glVertex3f(start_times[0].fx,start_times[0].fy,start_times[0].fz);
//	glVertex3f(start_times[1].fx,start_times[1].fy,start_times[1].fz);

/////	glColor3f(0,1,0);
//	glVertex3f(end_times[1].fx,end_times[1].fy,end_times[1].fz);
//	glVertex3f(end_times[0].fx,end_times[0].fy,end_times[0].fz);

	glEnd();

/////	glEnable(GL_LIGHTING);

	//adv declare empty array and stuff
//	imageOfVectorField = (float *) calloc( WINDOW_WIDTH*WINDOW_HEIGHT*3, sizeof(GL_UNSIGNED_BYTE) );
		if(bDsplyVectorFieldMode)
		{	//I can compute texture coordinates based on a flag HERE!!!!!!!!!!!!!!   ... if vector field changed, reset the flag
			if(newVectorTexture == 0)
			{
				//bunHits++;
				createVectorTexture();
				newVectorTexture = 1;
			}
			DrawVectorField(); //adv i'm going to add this here .. but first i need to declare the empty array?
		}

/*	
//	std::cout<<"Printing: "<<ff;

*/
	//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$	// GJB

//	xrot+=xspeed;	// Cool looking spinning.
//	yrot+=yspeed;

	return TRUE;										// Keep Going
}

//***************** Windowing Functions ********************//
GLvoid ReSizeGLScene(GLsizei width, GLsizei height)		// Resize And Initialize The GL Window
{
	if (height==0)										// Prevent A Divide By Zero By
	{
		height=1;										// Making Height Equal One
	}

	glViewport(0,0,width,height);						// Reset The Current Viewport

	glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
	glLoadIdentity();									// Reset The Projection Matrix

	// Calculate The Aspect Ratio Of The Window
	gluPerspective(45.0f,(GLfloat)width/(GLfloat)height,0.1f,100.0f);

	glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
	glLoadIdentity();									// Reset The Modelview Matrix
}

GLvoid KillGLWindow(GLvoid)								// Properly Kill The Window
{
	if (fullscreen)										// Are We In Fullscreen Mode?
	{
		ChangeDisplaySettings(NULL,0);					// If So Switch Back To The Desktop
		ShowCursor(TRUE);								// Show Mouse Pointer
	}

	if (hRC)											// Do We Have A Rendering Context?
	{
		if (!wglMakeCurrent(NULL,NULL))					// Are We Able To Release The DC And RC Contexts?
		{
			MessageBox(NULL,"Release Of DC And RC Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}

		if (!wglDeleteContext(hRC))						// Are We Able To Delete The RC?
		{
			MessageBox(NULL,"Release Rendering Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}
		hRC=NULL;										// Set RC To NULL
	}

	if (hDC && !ReleaseDC(hWnd,hDC))					// Are We Able To Release The DC
	{
		MessageBox(NULL,"Release Device Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hDC=NULL;										// Set DC To NULL
	}

	if (hWnd && !DestroyWindow(hWnd))					// Are We Able To Destroy The Window?
	{
		MessageBox(NULL,"Could Not Release hWnd.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hWnd=NULL;										// Set hWnd To NULL
	}

	if (!UnregisterClass("OpenGL",hInstance))			// Are We Able To Unregister Class
	{
		MessageBox(NULL,"Could Not Unregister Class.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hInstance=NULL;									// Set hInstance To NULL
	}

	KillFont();
}

/*	This Code Creates Our OpenGL Window.  Parameters Are:					*
 *	title			- Title To Appear At The Top Of The Window				*
 *	width			- Width Of The GL Window Or Fullscreen Mode				*
 *	height			- Height Of The GL Window Or Fullscreen Mode			*
 *	bits			- Number Of Bits To Use For Color (8/16/24/32)			*
 *	fullscreenflag	- Use Fullscreen Mode (TRUE) Or Windowed Mode (FALSE)	*/
 
BOOL CreateGLWindow(char* title, int width, int height, int bits, bool fullscreenflag)
{
	//adv
	WINDOW_WIDTH = width;
	WINDOW_HEIGHT = height;

	GLuint		PixelFormat;			// Holds The Results After Searching For A Match
	WNDCLASS	wc;						// Windows Class Structure
	DWORD		dwExStyle;				// Window Extended Style
	DWORD		dwStyle;				// Window Style
	RECT		WindowRect;				// Grabs Rectangle Upper Left / Lower Right Values
	WindowRect.left=(long)0;			// Set Left Value To 0
	WindowRect.right=(long)width;		// Set Right Value To Requested Width
	WindowRect.top=(long)0;				// Set Top Value To 0
	WindowRect.bottom=(long)height;		// Set Bottom Value To Requested Height

	fullscreen=fullscreenflag;			// Set The Global Fullscreen Flag

	hInstance			= GetModuleHandle(NULL);				// Grab An Instance For Our Window
	wc.style			= CS_HREDRAW | CS_VREDRAW | CS_OWNDC;	// Redraw On Size, And Own DC For Window.
	wc.lpfnWndProc		= (WNDPROC) WndProc;					// WndProc Handles Messages
	wc.cbClsExtra		= 0;									// No Extra Window Data
	wc.cbWndExtra		= 0;									// No Extra Window Data
	wc.hInstance		= hInstance;							// Set The Instance
	wc.hIcon			= LoadIcon(NULL, IDI_WINLOGO);			// Load The Default Icon
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);			// Load The Arrow Pointer
	wc.hbrBackground	= NULL;									// No Background Required For GL
	wc.lpszMenuName		= NULL;									// We Don't Want A Menu
	wc.lpszClassName	= "OpenGL";								// Set The Class Name

	if (!RegisterClass(&wc))									// Attempt To Register The Window Class
	{
		MessageBox(NULL,"Failed To Register The Window Class.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}
	
	if (fullscreen)												// Attempt Fullscreen Mode?
	{
		DEVMODE dmScreenSettings;								// Device Mode
		memset(&dmScreenSettings,0,sizeof(dmScreenSettings));	// Makes Sure Memory's Cleared
		dmScreenSettings.dmSize=sizeof(dmScreenSettings);		// Size Of The Devmode Structure
		dmScreenSettings.dmPelsWidth	= width;				// Selected Screen Width
		dmScreenSettings.dmPelsHeight	= height;				// Selected Screen Height
		dmScreenSettings.dmBitsPerPel	= bits;					// Selected Bits Per Pixel
		dmScreenSettings.dmFields=DM_BITSPERPEL|DM_PELSWIDTH|DM_PELSHEIGHT;

		// Try To Set Selected Mode And Get Results.  NOTE: CDS_FULLSCREEN Gets Rid Of Start Bar.
		if (ChangeDisplaySettings(&dmScreenSettings,CDS_FULLSCREEN)!=DISP_CHANGE_SUCCESSFUL)
		{
			// If The Mode Fails, Offer Two Options.  Quit Or Use Windowed Mode.
			if (MessageBox(NULL,"The Requested Fullscreen Mode Is Not Supported By\nYour Video Card. Use Windowed Mode Instead?","NeHe GL",MB_YESNO|MB_ICONEXCLAMATION)==IDYES)
			{
				fullscreen=FALSE;		// Windowed Mode Selected.  Fullscreen = FALSE
			}
			else
			{
				// Pop Up A Message Box Letting User Know The Program Is Closing.
				MessageBox(NULL,"Program Will Now Close.","ERROR",MB_OK|MB_ICONSTOP);
				return FALSE;									// Return FALSE
			}
		}
	}

	if (fullscreen)												// Are We Still In Fullscreen Mode?
	{
		dwExStyle=WS_EX_APPWINDOW;								// Window Extended Style
		dwStyle=WS_POPUP;										// Windows Style
		ShowCursor(FALSE);										// Hide Mouse Pointer
	}
	else
	{
		dwExStyle=WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;			// Window Extended Style
		dwStyle=WS_OVERLAPPEDWINDOW;							// Windows Style
	}

	AdjustWindowRectEx(&WindowRect, dwStyle, FALSE, dwExStyle);		// Adjust Window To True Requested Size

	// Create The Window
	if (!(hWnd=CreateWindowEx(	dwExStyle,							// Extended Style For The Window
								"OpenGL",							// Class Name
								title,								// Window Title
								dwStyle |							// Defined Window Style
								WS_CLIPSIBLINGS |					// Required Window Style
								WS_CLIPCHILDREN,					// Required Window Style
								0, 0,								// Window Position
								WindowRect.right-WindowRect.left,	// Calculate Window Width
								WindowRect.bottom-WindowRect.top,	// Calculate Window Height
								NULL,								// No Parent Window
								NULL,								// No Menu
								hInstance,							// Instance
								NULL)))								// Dont Pass Anything To WM_CREATE
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Window Creation Error.","ERROR",MB_OK|MB_ICONEXCLAMATION); //adv ex. of message to screen
		return FALSE;								// Return FALSE
	}

	static	PIXELFORMATDESCRIPTOR pfd=				// pfd Tells Windows How We Want Things To Be
	{
		sizeof(PIXELFORMATDESCRIPTOR),				// Size Of This Pixel Format Descriptor
		1,											// Version Number
		PFD_DRAW_TO_WINDOW |						// Format Must Support Window
		PFD_SUPPORT_OPENGL |						// Format Must Support OpenGL
		PFD_DOUBLEBUFFER,							// Must Support Double Buffering
		PFD_TYPE_RGBA,								// Request An RGBA Format
		bits,										// Select Our Color Depth
		0, 0, 0, 0, 0, 0,							// Color Bits Ignored
		0,											// No Alpha Buffer
		0,											// Shift Bit Ignored
		0,											// No Accumulation Buffer
		0, 0, 0, 0,									// Accumulation Bits Ignored
		16,											// 16Bit Z-Buffer (Depth Buffer)  
		0,											// No Stencil Buffer
		0,											// No Auxiliary Buffer
		PFD_MAIN_PLANE,								// Main Drawing Layer
		0,											// Reserved
		0, 0, 0										// Layer Masks Ignored
	};
	
	if (!(hDC=GetDC(hWnd)))							// Did We Get A Device Context?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Create A GL Device Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if (!(PixelFormat=ChoosePixelFormat(hDC,&pfd)))	// Did Windows Find A Matching Pixel Format?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Find A Suitable PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if(!SetPixelFormat(hDC,PixelFormat,&pfd))		// Are We Able To Set The Pixel Format?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Set The PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if (!(hRC=wglCreateContext(hDC)))				// Are We Able To Get A Rendering Context?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Create A GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if(!wglMakeCurrent(hDC,hRC))					// Try To Activate The Rendering Context
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Activate The GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	ShowWindow(hWnd,SW_SHOW);						// Show The Window
	SetForegroundWindow(hWnd);						// Slightly Higher Priority
	SetFocus(hWnd);									// Sets Keyboard Focus To The Window
	ReSizeGLScene(width, height);					// Set Up Our Perspective GL Screen

	if (!InitGL())									// Initialize Our Newly Created GL Window
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Initialization Failed.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	return TRUE;									// Success
}

LRESULT CALLBACK WndProc(	HWND	hWnd,			// Handle For This Window
							UINT	uMsg,			// Message For This Window
							WPARAM	wParam,			// Additional Message Information
							LPARAM	lParam)			// Additional Message Information
{
	static GLuint   stateMouse   = 0;
	static bool		bAltKey = false;

	static float ox = 0.f;
	static float oy = 0.f;

	switch (uMsg)									// Check For Windows Messages
	{
		case WM_ACTIVATE:							// Watch For Window Activate Message
		{
			if (!HIWORD(wParam))					// Check Minimization State
			{
				active=TRUE;						// Program Is Active
			}
			else
			{
				active=FALSE;						// Program Is No Longer Active
			}

			return 0;								// Return To The Message Loop
		} 

		case WM_SYSCOMMAND:							// Intercept System Commands
		{
			switch (wParam)							// Check System Calls
			{
				case SC_SCREENSAVE:					// Screensaver Trying To Start?
				case SC_MONITORPOWER:				// Monitor Trying To Enter Powersave?
				return 0;							// Prevent From Happening
			}
			break;									// Exit
		}

		case WM_CLOSE:								// Did We Receive A Close Message?
		{
			PostQuitMessage(0);						// Send A Quit Message
			return 0;								// Jump Back
		}

		case WM_KEYDOWN:							// Is A Key Being Held Down?
		{
			keys[wParam] = TRUE;					// If So, Mark It As TRUE
			return 0;								// Jump Back
		}

		case WM_KEYUP:								// Has A Key Been Released?
		{
			keys[wParam] = FALSE;					// If So, Mark It As FALSE
			return 0;								// Jump Back
		}
		case WM_SYSKEYDOWN:
		{
			if( wParam == VK_MENU ) { // Alt-key pressed
				bAltKey = true;
			}
			return 0;
		}
		case WM_SYSKEYUP:
		{
			if( wParam == VK_MENU ) { // Alt-key released
				bAltKey = false;
			}
			return 0;
		}
		case WM_LBUTTONDOWN:
		{
			mouse_x = LOWORD(lParam);    //adv      
			mouse_y = HIWORD(lParam);	//adv
			Selection(); //adv i commented out the rest of this box for now
	//		vectorInfo(); //adv
			InitGL(); //adv tried this again on 6.24
/*			if( bAltKey ) {		// If Alt-key still pressed and Left-mouse-button clicked...
				SetCapture(hWnd);
				stateMouse |= LMBUTT;
				ox = LOWORD(lParam);
				oy = HIWORD(lParam);
				
				//adv i was trying some mouse motion here
			}
	*/		return 0;
		}
		case WM_MOUSEMOVE:
		{
			mouse_x = LOWORD(lParam);    //adv      
			mouse_y = HIWORD(lParam);	//adv; i commented out the rest of this box for now

	/*		if( !stateMouse )
				return 0;

			float mx = LOWORD(lParam);
			float my = HIWORD(lParam);
			z += (ox - mx)/100;
			PostMessage(hWnd, WM_PAINT, 0, 0);
	*/		return 0;
		}
		case WM_LBUTTONUP:
		{
			ReleaseCapture(); // Remember to release the capture when we are finished.
			stateMouse = 0;
			return 0;
		}
		case WM_SIZE:								// Resize The OpenGL Window
		{
			ReSizeGLScene(LOWORD(lParam),HIWORD(lParam));  // LoWord=Width, HiWord=Height
			return 0;								// Jump Back
		}
		case WM_PAINT:
		{
			DrawGLScene();
			SwapBuffers(hDC);	// Only repaint when the window has been invalidated 
								// (by some other app or explicitly: InvalidateRect(hWnd, NULL, NULL ).
		}
	}

	// Pass All Unhandled Messages To DefWindowProc
	return DefWindowProc(hWnd,uMsg,wParam,lParam);
}

//adv this is the main function
int WINAPI WinMain(	HINSTANCE	hInstance,			// Instance
					HINSTANCE	hPrevInstance,		// Previous Instance
					LPSTR		lpCmdLine,			// Command Line Parameters
					int			nCmdShow)			// Window Show State
{

	MSG		msg;									// Windows Message Structure
	BOOL	done=FALSE;								// Bool Variable To Exit Loop

	strcpy( InPlyFileName, lpCmdLine );

	fullscreen=FALSE;

	// Create Our OpenGL Window 
//bunh and binhits were to keep track of trying to make Picking work- it was how many times teh mouse clicked teh model
float bunh = (float)bunHits;
 char bh[10];
 sprintf(bh, "%G", bunh);

	if (!CreateGLWindow("OpenGL Ply Viewer",512,512,16,fullscreen))
	{
		return 0;									// Quit If Window Was Not Created
	}

//	MessageBox(NULL,bh,"BUNHITS",MB_OK|MB_ICONEXCLAMATION); 

	while (GetMessage(&msg, NULL, 0, 0) == TRUE && !done) {
		if (keys[VK_ESCAPE])
			done=TRUE;
        TranslateMessage(&msg);
        DispatchMessage(&msg);
		ProcessUIs();
    }

	bunh = (float)bunHits;
  bh[10];

   sprintf(bh, "%G", bunh);
 //  MessageBox(NULL,bh,"BUNHITS",MB_OK|MB_ICONEXCLAMATION); 
 

char finStuff[30]; //y value .402275 //z is .024 //x is -.0014
float testing = maxYVertex->fy;
sprintf(finStuff,"value is: %f\n",testing);
//MessageBox(NULL,finStuff,"FINVERTEX",MB_OK|MB_ICONEXCLAMATION); 

	 fclose(logfile);  //adv trying to close log file 6/13
	// Shutdown
	KillGLWindow();									// Kill The Window
	return (msg.wParam);							// Exit The Program
}

/*************************************************************************************/
// User-Interface functions and variables

int	keyCnt_h = 0;
bool bMenuHeadsUp = false;

// Display Modes
int	keyCnt_m = 0;
bool bDsplyWireMode = false;
bool bDsplyFlatMode = true;
bool bDsplyNormalsMode = false;
bool bDsplyTextureMode = false;

// Backface Culling Modes
int	keyCnt_c = 0;
bool bBckCullOff = true;
bool bBckCullCW = false;
bool bBckCullCCW = false;

// Dumping renderings to image file
int keyCnt_d = 0;

void ProcessUIs() {
/*				if (keys['L'] && !lp)
	{
		lp=TRUE;
		light=!light;
		if (!light)
		{
			//glDisable(GL_LIGHTING);
		}
		else
		{
			//glEnable(GL_LIGHTING);
		}
	}
	if (!keys['L'])
	{
		lp=FALSE;
	}
*/		
	if(keys['H'] && !keyCnt_h) {		// First check if the key was hit, was it the 1st time?
		keyCnt_h++;
		bMenuHeadsUp = !bMenuHeadsUp;
		InvalidateRect(hWnd, NULL, NULL );
	}
	else if(!keys['H']) {				// Else check if the key has been released; reset the counter.
		keyCnt_h = false;
	}
	if (keys['F'] && !fp)
	{
		fp=TRUE;
		filter+=1;
		if (filter>2)
		{
			filter=0;
		}
		InvalidateRect(hWnd, NULL, NULL );
	}
	else if (!keys['F'])
	{
		fp=FALSE;
	}
	if(keys['M'] && !keyCnt_m) {
		keyCnt_m++;
		if( bDsplyVectorFieldMode ) {
			bDsplyWireMode = false;
			bDsplyFlatMode = true;
			bDsplyNormalsMode = false;
			bDsplyTextureMode = false;
			bDsplyVectorFieldMode = false;
		}
		else if( bDsplyFlatMode ) {
			bDsplyWireMode = false;
			bDsplyFlatMode = false;
			bDsplyNormalsMode = true;
			bDsplyTextureMode = false;
			bDsplyVectorFieldMode = false;
		}
		else if( bDsplyNormalsMode ) {
			bDsplyWireMode = false;
			bDsplyFlatMode = false;
			bDsplyNormalsMode = false;
			bDsplyTextureMode = true;
			bDsplyVectorFieldMode = false;
		}
		else if( bDsplyTextureMode ) {
			bDsplyWireMode = true;
			bDsplyFlatMode = false;
			bDsplyNormalsMode = false;
			bDsplyTextureMode = false;
			bDsplyVectorFieldMode = false;
		}
		else if( bDsplyWireMode ) {
			bDsplyWireMode = false;
			bDsplyFlatMode = false;
			bDsplyNormalsMode = false;
			bDsplyTextureMode = false;
			bDsplyVectorFieldMode = true;
		}
		RemLastCallListItems(1);
		AddPlyMeshToCallList();
		InvalidateRect(hWnd, NULL, NULL );
	}
	else if (!keys['M']) {
		keyCnt_m = false;
	}

	if(keys['C'] && !keyCnt_c) {
		keyCnt_c++;
		if( bBckCullOff ) {
			bBckCullOff = false;
			bBckCullCW = true;
			bBckCullCCW = false;
		}
		else if( bBckCullCW ) {
			bBckCullOff = false;
			bBckCullCW = false;
			bBckCullCCW = true;
		}
		else if( bBckCullCCW ) {
			bBckCullOff = true;
			bBckCullCW = false;
			bBckCullCCW = false;
		}
//		RemLastCallListItems(1);
//		AddPlyMeshToCallList();
		InvalidateRect(hWnd, NULL, NULL );
	}
	else if (!keys['C']) {
		keyCnt_c = false;
	}
	if(keys['D'] && !keyCnt_d) {
		keyCnt_d++;
		//SaveImageAsBMP( "tmp.bmp" );
		

		char file1name[100] = {""};
		char a_frame_num[20];
		static int i=0;
		//CString seqName;
		//seqName = "spin";
		for( ; i < (360.f/SPINSPEED); i++ ) {
			yspeed+=SPINSPEED; //InvalidateRect(hWnd, NULL, NULL );
			DrawGLScene();
			SwapBuffers(hDC);
			//PostMessage(hWnd, WM_PAINT, 0, 0);
			//_itoa( frame, a_frame_num, 10 );
			sprintf(a_frame_num,"%.4d", i);
			sprintf( file1name, "frames\\spin" );
			//seqName += seqNumString + ".bmp";
			//imgOut.WriteFile(seqName);
			strcat( file1name, a_frame_num );
			strcat( file1name, ".bmp" );
			SaveImageAsBMP( file1name );
		}
	}
	else if( !keys['D']) {
		keyCnt_d = false;
	}
	if (keys['W'])	{					
		pPlyMesh->WritePlyMesh ("new_rot_back.ply"); //, FALSE);		
	}
	if (keys[VK_PRIOR])
	{
		//z-=0.2f; InvalidateRect(hWnd, NULL, NULL );
		//adv trying to slow down zoom
		z-=0.1f; InvalidateRect(hWnd, NULL, NULL );
	}
	if (keys[VK_NEXT])
	{ //adv was .2
		z+=0.1f; InvalidateRect(hWnd, NULL, NULL );
	}
	if (keys[VK_UP])
	{
		newVectorTexture = 0; //adv trying this
		xspeed-=SPINSPEED; InvalidateRect(hWnd, NULL, NULL );
	}
	if (keys[VK_DOWN])
	{
		newVectorTexture = 0; //adv trying this
		xspeed+=SPINSPEED; InvalidateRect(hWnd, NULL, NULL );
	}
	if (keys[VK_RIGHT])
	{
		newVectorTexture = 0; //adv trying this
		yspeed+=SPINSPEED; InvalidateRect(hWnd, NULL, NULL );
	}
	if (keys[VK_LEFT])
	{
		newVectorTexture = 0; //adv trying this
		yspeed-=SPINSPEED; InvalidateRect(hWnd, NULL, NULL );
	}
	// Blending Code Starts Here
/*				if (keys['B'] && !bp)
	{
		bp=TRUE;
		blend = !blend;
		if(blend)
		{
			tmp2 = 2772;
			//glEnable(GL_BLEND);			// Turn Blending On
			//glDisable(GL_DEPTH_TEST);	// Turn Depth Testing Off
		}
		else
		{
			tmp2 = 2771;
			//glDisable(GL_BLEND);		// Turn Blending Off
			//glEnable(GL_DEPTH_TEST);	// Turn Depth Testing On
		}
	}
	if (!keys['B'])
	{
		bp=FALSE;
	}
*/				// Blending Code Ends Here

	if (keys[VK_F1])						// Is F1 Being Pressed?
	{
		keys[VK_F1]=FALSE;					// If So Make Key FALSE
		KillGLWindow();						// Kill Our Current Window
		fullscreen=!fullscreen;				// Toggle Fullscreen / Windowed Mode
		// Recreate Our OpenGL Window
		if (!CreateGLWindow("OpenGL Ply Viewer",640,480,16,fullscreen))
		{
			return;						// Quit If Window Was Not Created
		}
	}
}


void RenderHeadsUpText() {
	if( !bMenuHeadsUp )
		return;		// No HeadsUp info requested.
	
	float curHoffset = -1.05f;
	float curVoffset = 0.75f;
	
	std::vector<char*> TxtEntries;

	char txtHeadsUp[] = { "Heads-Up help display = <h> " };
	char txtBlankSpace[] = {" "};
	char txtDsplyMode[] = { "Step display modes = <m> " };
	char txtBfaceCullMode[] = { "Step backface modes = <c> " };
	
	TxtEntries.push_back( txtHeadsUp );
	TxtEntries.push_back( txtBlankSpace );
	TxtEntries.push_back( txtDsplyMode );
	TxtEntries.push_back( txtBfaceCullMode );

	glPushMatrix();
		glColor3ub(255, 255, 0);
		glTranslatef(0.0, 0.0, -2.0); // z=-1.5 would be enough, but use 2 to make (x,y) range [-1,1]
		
		std::vector<char*>::iterator TxtEntryIt;
		for( TxtEntryIt = TxtEntries.begin(); TxtEntryIt != TxtEntries.end(); TxtEntryIt++ ) {
			glRasterPos2f( curHoffset, curVoffset );	// Use spacing of 0.05 between lines.
			ScreenPrint( *TxtEntryIt );	// Print GL Text

			curVoffset -= 0.05f;
			if( curVoffset < -1.f ) { curHoffset=0.0f; curVoffset = 0.75f; }
		}
		
/*		glRasterPos2f(-1.0f,-0.73f);	// Use spacing of 0.05 between lines.
		ScreenPrint("Active text \ndisplay");	// Print GL T

		glRasterPos2f(-1.0f,-0.68f);	
		ScreenPrint("Active text \ndisplay");	// Print GL T

		glRasterPos2f(-1.0f, 0.70f);	
		ScreenPrint("Active text \ndisplay");	// Print GL T
*/		//ScreenPrint("Active OpenGL Text With NeHe - %7.2f", cnt1);	// Print GL T
		glTranslatef(0.0, 0.0, 2.0);
	glPopMatrix();

// Cleanup of temporary structures:
// No need to deallocate strings, as these are local variables anyway:
/*	for( TxtEntryIt = TxtEntries.begin(); TxtEntryIt != TxtEntries.end(); TxtEntryIt++ ) {
		delete( *TxtEntryIt );
		*TxtEntryIt = NULL;
	}
*/	TxtEntries.clear();
}

GLvoid ScreenPrint(const char *fmt, ...)					// Custom GL "Print" Routine
{
	char		text[256];								// Holds Our String
	va_list		ap;										// Pointer To List Of Arguments

	if (fmt == NULL)									// If There's No Text
		return;											// Do Nothing

	va_start(ap, fmt);									// Parses The String For Variables
	    vsprintf(text, fmt, ap);						// And Converts Symbols To Actual Numbers
	va_end(ap);											// Results Are Stored In Text

	glPushAttrib(GL_LIST_BIT);							// Pushes The Display List Bits
	glListBase(base - 32);								// Sets The Base Character to 32
	glCallLists(strlen(text), GL_UNSIGNED_BYTE, text);	// Draws The Display List Text
	glPopAttrib();										// Pops The Display List Bits
}

void ActivatePolyModeAndLighting() {
	if( bDsplyWireMode ) {
		// MAINMENU wireframe default
		glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
		glShadeModel (GL_FLAT);
		glDisable(GL_LIGHTING);
		glDisable(GL_LIGHT0);
		glColor3ub(255, 255, 255);
	}
	else if( bDsplyFlatMode ) {
		// LightMENU
		glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
		glShadeModel(GL_FLAT);
		glEnable(GL_LIGHTING);
		glEnable(GL_LIGHT0);
		glEnable(GL_LIGHT1);
		glColor3ub(255, 255, 255);
		//*******************************************************************************************************************adv copy this //
	}
	else if( bDsplyNormalsMode || bDsplyTextureMode) { //or added by adv on 6/14
		// GEOMMENU 
		// note: toggle color-calculation based on normals (in call-list construction)
		glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
		glShadeModel (GL_FLAT);
		glDisable(GL_LIGHTING);
		glDisable(GL_LIGHT0);
	}
	else if( bDsplyVectorFieldMode ) { //added by adv 6/13
		// Vector Stuff
		glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
		glShadeModel (GL_FLAT);
		glDisable(GL_LIGHTING);
		glDisable(GL_LIGHT0);
	}

	if( bBckCullOff ) {
		glDisable(GL_CULL_FACE);
	}
	else if( bBckCullCW ) {
		glFrontFace(GL_CW);	
		glEnable(GL_CULL_FACE);
		glCullFace(GL_BACK);
	}
	else if( bBckCullCCW ) {
		glFrontFace(GL_CCW);
		glEnable(GL_CULL_FACE);
		glCullFace(GL_BACK);
	}
}

//******************** Bitmap Functions ***************************//
void SaveImageAsBMP(char *path)
{
	// ************************
	// Writes image to BMP file
	// ************************
	FILE *bmp = fopen(path, "wb");
	char tag[] = "BM";
	long data;
	
	if(!bmp)
	{
		fprintf(stdout, "Can't open file \"%s\"\n", path);
		return;
	}
	// ****************
	// Write BMP header
	// ****************
	fwrite(tag, sizeof(char), 2, bmp);
	data = 0x36 + VIEW_X*VIEW_Y*3;
	fwrite(&data, sizeof(long), 1, bmp);
	data = 0;
	fwrite(&data, sizeof(long), 1, bmp);
	data = 0x36;
	fwrite(&data, sizeof(long), 1, bmp);
	data = 0x28;
	fwrite(&data, sizeof(long), 1, bmp);
	data = VIEW_X;
	fwrite(&data, sizeof(long), 1, bmp);
	data = VIEW_Y;
	fwrite(&data, sizeof(long), 1, bmp);
	short sdata = 1;
	fwrite(&sdata, sizeof(short), 1, bmp);
	sdata = 24;
	fwrite(&sdata, sizeof(short), 1, bmp);
	data = 0;
	fwrite(&data, sizeof(long), 1, bmp);
	fwrite(&data, sizeof(long), 1, bmp);
	data = 0xB12;
	fwrite(&data, sizeof(long), 1, bmp);
	fwrite(&data, sizeof(long), 1, bmp);
	data = 0;
	fwrite(&data, sizeof(long), 1, bmp);
	fwrite(&data, sizeof(long), 1, bmp);
	
	// **************************
	// Allocate buffer for pixels
	// **************************
	unsigned char *pix = (unsigned char*)malloc(VIEW_X*VIEW_Y*3);
	if(!pix) exit(-1);
	
	// ************************
	// Redraw view, grab pixels
	// ************************
	//Redraw(); // gets rid of zoom box, but not slice hilite
	
	glReadPixels(ICON_BAR, STAT_BAR,
	             VIEW_X, VIEW_Y, GL_RGB, GL_UNSIGNED_BYTE, pix);
	
	// ************************
	// Convert BGR->RGB for BMP
	// ************************
	for(int i = 0; i < VIEW_X*VIEW_Y; i++)
	{
		pix_t ptmp = pix[i*3+2];
		pix[i*3+2] = pix[i*3];
		pix[i*3]   = (unsigned char)ptmp; // added cast to (unsigned char)
	}
	// *************************************
	// Write pixels, close file, free buffer
	// *************************************

	// WriteBitmap("tmp2.bmp", (camRGB*)pix, VIEW_X, VIEW_Y); // Alternate writing to bmp.
	fwrite(pix, 1, VIEW_X*VIEW_Y*3, bmp);
	
	fclose(bmp);
	free(pix);
}

int WriteBitmap(char *name, camRGB *buf, unsigned x, unsigned y)
{
    int rc=0;
    BITMAPFILEHEADER bmfHeader;
    BITMAPINFOHEADER bmiHeader;
    FILE *file;

    bmfHeader.bfType=DIB_HEADER_MARKER;

	bmfHeader.bfSize=sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER)+x*y*sizeof(camRGB);
	bmfHeader.bfReserved1=0;
	bmfHeader.bfReserved2=0;
	bmfHeader.bfOffBits=sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER);

    bmiHeader.biSize=sizeof(BITMAPINFOHEADER);
    bmiHeader.biWidth=x;
    bmiHeader.biHeight=y;
    bmiHeader.biPlanes=1;
    bmiHeader.biBitCount=24;
    bmiHeader.biCompression=BI_RGB;
    bmiHeader.biSizeImage=sizeof(camRGB)*x*y;
    bmiHeader.biXPelsPerMeter=3780;
    bmiHeader.biYPelsPerMeter=3780;
    bmiHeader.biClrUsed=0; 
    bmiHeader.biClrImportant=0;

    if(file=fopen(name,"wb")) {
        if(fwrite(&bmfHeader,sizeof(bmfHeader),1,file)==1) 
            if(fwrite(&bmiHeader,sizeof(bmiHeader),1,file)==1) 
				if(fwrite(buf,sizeof(camRGB),x*y,file)==x*y) 
                    rc=1;
        if(fclose(file)) rc=0;
    }
    return rc;
}



