#ifndef _PLY_VIEW_SIMPLE_MAIN_H_
#define _PLY_VIEW_SIMPLE_MAIN_H_

#include <windows.h>		// Header File For Windows
#include <gl\gl.h>			// Header File For The OpenGL32 Library
#include <stdio.h>			// Header File For Standard Input/Output

#define SPINSPEED 0.80f

enum { 
    LMBUTT = 1,				/* pan state bit */
    RMBUTT,					/* rotate state bits */
	MMBUTT					/* zoom state bit */
};


LRESULT	CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);	// Declaration For WndProc
GLvoid	KillGLWindow(GLvoid);
BOOL	CreateGLWindow(char* title, int width, int height, int bits, bool fullscreenflag);

int		DrawGLScene(GLvoid);

void	AddPlyMeshToCallList();
int		RemLastCallListItems( int num );




// # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
// Just for manageUI.cpp:
//
void	ProcessUIs();
void	RenderHeadsUpText();
GLvoid	ScreenPrint(const char *fmt, ...);
void ActivatePolyModeAndLighting();
// # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




// # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
//	Grab contents of GL rendering context to a buffer, rotate the colors, 
//	and save to .bmp file:
// For dumping bmp's based on http://bork.hampshire.edu/~bernie/demo4/source/
#define VIEW_X 640	// TODO: make the SaveImageAsBMP check what the actual rendering width/height is,
#define VIEW_Y 480	// TODO: instead of assuming these presets.
#define ICON_BAR       0
#define STAT_BAR       0
typedef long pix_t; // 32bpp
void SaveImageAsBMP(char *path);

// Alternate bitmap-writing. This is cleaner, but still needs color-rotation like above.
struct camRGB {
	unsigned char b;
	unsigned char g;
	unsigned char r;
};
#define DIB_HEADER_MARKER   ((WORD) ('M' << 8) | 'B')
int WriteBitmap(char *name, camRGB *buf, unsigned x, unsigned y);
// # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

#endif // _PLY_VIEW_SIMPLE_MAIN_H_