// PlyMesh.cpp: implementation of the CPlyMesh class.
//
//////////////////////////////////////////////////////////////////////

//#include "stdafx.h"
#include "plyMesh.h"

#include <stdlib.h>
#include <string.h>
#include <assert.h>
//added by adv from flowply on 6/1
#include <math.h>

extern int bunHits; //adv
//adv, this is my substitute for options from flowply, until i know whether i need it or not
	int maxStart = 1; //PUT THIS BACK TO 3 SOON
	int maxEnd = 1;
	int maxExtremeties = maxStart+maxEnd; //adv I'll make this global later
//	float * start_times = (float *)malloc(sizeof(float)*maxStart);
//	float * end_times = (float *)malloc(sizeof(float)*maxEnd);
	sVertex * start_times = (sVertex *)malloc(sizeof(sVertex)*maxStart);
	sVertex * end_times = (sVertex *)malloc(sizeof(sVertex)*maxEnd);

float thresh = 0.05;
int diffusion_iterations = 10;
float diffusion_threshold = 0.0;
extern sVertex* minVertex; 
extern sVertex* finVertex;

//Globals
PlyProperty vert_props[] = { /* list of property information for a vertex */
  {"x", Float32, Float32, offsetof(Vertex,fx), 0, 0, 0, 0},
  {"y", Float32, Float32, offsetof(Vertex,fy), 0, 0, 0, 0},
  {"z", Float32, Float32, offsetof(Vertex,fz), 0, 0, 0, 0},
  {"r", Float32, Float32, offsetof(Vertex,fr), 0, 0, 0, 0},
  {"g", Float32, Float32, offsetof(Vertex,fg), 0, 0, 0, 0},
  {"b", Float32, Float32, offsetof(Vertex,fb), 0, 0, 0, 0},
  {"nx", Float32, Float32, offsetof(Vertex,fnx), 0, 0, 0, 0},
  {"ny", Float32, Float32, offsetof(Vertex,fny), 0, 0, 0, 0},
  {"nz", Float32, Float32, offsetof(Vertex,fnz), 0, 0, 0, 0},
  {"s", Float32, Float32, offsetof(Vertex,s), 0, 0, 0, 0},
  {"t", Float32, Float32, offsetof(Vertex,t), 0, 0, 0, 0}
};

PlyProperty face_props[] = { /* list of property information for a face */
  {"vertex_indices", Int32, Int32, offsetof(Face,pi_verts),  1, Uint8, Uint8, offsetof(Face,ucNumVerts)},
};


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CPlyMesh::CPlyMesh()
{
	m_pVertexList	= NULL;
    m_pFaceList		= NULL;

	m_iFileType		  = 0;
}


CPlyMesh::~CPlyMesh()
{
	unsigned int i;

	if (m_iNumVertices) {
		for (i=0; i<m_iNumVertices; i++)
			free(m_pVertexList[i]);
	}

	if (m_iNumFaces) {
		for (i=0; i<m_iNumFaces; i++)
			free(m_pFaceList[i]);
	}
}


int per_vertex_color;
int has_normals;
int has_texture_coords;
PlyOtherProp *vert_other, *face_other;

//added by adv on 6/1 from flowply -- right now, not part of class; if they become part, i'll add them lower than this
void CPlyMesh::normalize_vec (double* vec)
{
  double len;

  //len = vec[0] * vec[0] + vec[1] * vec[1] + vec[2] * vec[2];
  len = dot(vec, vec);
  len = sqrt(len);

  if (len > 0.0) {
    vec[0] = vec[0]/len;
    vec[1] = vec[1]/len;
    vec[2] = vec[2]/len;
  }
  else {
    vec[0] = 0.0;
    vec[1] = 0.0;
    vec[2] = 0.0;
    //printf ("Length is close to 0.0\n");
  }
}

double CPlyMesh::dot (double* v1, double* v2)
{
  double prod;

  prod = v1[0] * v2[0] + v1[1] * v2[1] + v1[2] * v2[2];
  return prod;
}

void CPlyMesh::cross (double* v1, double* v2, double* dest)
{
  double temp[3];

  temp[0] = v1[1]*v2[2] - v1[2]*v2[1];
  temp[1] = v1[2]*v2[0] - v1[0]*v2[2];
  temp[2] = v1[0]*v2[1] - v1[1]*v2[0];

  dest[0] = temp[0]; dest[1] = temp[1]; dest[2] = temp[2];
}

double CPlyMesh::area (double* v1, double* v2)
{
  double len;
  double cross_prod[3];
  
  cross (v1, v2, cross_prod);

  len = dot(cross_prod, cross_prod);
  len = sqrt(len);

  return (len / 2.0);
} 

//end stuff added by adv

//this is added by ad on 6/1 as part of the class, whil the others like it, above were not part of the class....now are
double CPlyMesh::area (sFace* tri)
{
  double v1[3], v2[3];

  v1[0] = m_pVertexList[tri->pi_verts[1]]->fx - m_pVertexList[tri->pi_verts[0]]->fx;
  v1[1] = m_pVertexList[tri->pi_verts[1]]->fy - m_pVertexList[tri->pi_verts[0]]->fy;
  v1[2] = m_pVertexList[tri->pi_verts[1]]->fz - m_pVertexList[tri->pi_verts[0]]->fz;
  v2[0] = m_pVertexList[tri->pi_verts[2]]->fx - m_pVertexList[tri->pi_verts[0]]->fx;
  v2[1] = m_pVertexList[tri->pi_verts[2]]->fy - m_pVertexList[tri->pi_verts[0]]->fy;
  v2[2] = m_pVertexList[tri->pi_verts[2]]->fz - m_pVertexList[tri->pi_verts[0]]->fz;

  return area (v1, v2);
} 
//end method added by adv

//adv's new version of reading the plymesh
void CPlyMesh::ReadPlyMesh(char *szFileName)
{
  unsigned int elem_count;
  char *elem_name;
  PlyFile *pPly;

  int i,k;	//GJB added k
  unsigned int j;	//GJB made j unsigned int

  FILE *fp = fopen(szFileName, "r");
  pPly  = read_ply (fp);
//this is for the number of elements- in this case we have 2- verticies and faces?
  int * double_vertex_list;
	 
  for (i = 0; i < pPly->num_elem_types; i++) 
  {

    // prepare to read the i'th list of elements --adv that is... if the first list is of verticies, prepare to read it
    elem_name = setup_element_read_ply (pPly, i, (int *) &elem_count);

	//adv if this list is a list of verticies
    if (equal_strings ("vertex", elem_name)) 
	{
	  //int origVertCount = elem_count; //adv
	  int actualVertCount = 0; //adv
	  
      // create a vertex list to hold all the original vertices  
	  //as i get it , i have to change it's face property? ... i'll create 3 lists, then? one with all orig, one the size of ogir, but populated only with doubles' place in teh array, and one the size of singles ... NO, only 2, and the first one, i just don't save teh doubles, it will be too big, but will only have singles 
	  m_pVertexList = (Vertex **) malloc (sizeof (Vertex *) * elem_count);
//       m_iNumVertices = elem_count; //adv we want to set this later, to be the actual count

	  double_vertex_list = (int *) calloc(sizeof (int), elem_count); //adv this is a list that points to ints, which are doubles ... hmmm
	  //adv initialize whole list to -777
	  for(int advTry=0; advTry<elem_count; advTry++)
	  {
		  double_vertex_list[advTry]=-777;
	  }
	 
      //adv we are given the vertex's x,y, and z first, and the normal's x, y, and z later
	  // set up for getting vertex elements 
      setup_property_ply (pPly, &vert_props[0]);
      setup_property_ply (pPly, &vert_props[1]);
      setup_property_ply (pPly, &vert_props[2]);

      for (k = 0; k < pPly->elems[i]->nprops; k++) //from 0 to the number of properties of each element?
	  {
		PlyProperty *prop;
		prop = pPly->elems[i]->props[k];

		if (equal_strings ("r", prop->name)) {
		  setup_property_ply (pPly, &vert_props[3]);
		  per_vertex_color = 1;
		}
		if (equal_strings ("g", prop->name)) {
		  setup_property_ply (pPly, &vert_props[4]);
		  per_vertex_color = 1;
		}
		if (equal_strings ("b", prop->name)) {
		  setup_property_ply (pPly, &vert_props[5]);
		  per_vertex_color = 1;
		}
		if (equal_strings ("nx", prop->name)) { //adv these three will be things we are storing
		  setup_property_ply (pPly, &vert_props[6]);
		  has_normals = 1;
		}
		if (equal_strings ("fny", prop->name)) {
		  setup_property_ply (pPly, &vert_props[7]);
		  has_normals = 1;
		}
		if (equal_strings ("nz", prop->name)) {
		  setup_property_ply (pPly, &vert_props[8]);
		  has_normals = 1;
		}
		if (equal_strings ("s", prop->name)) {
		  setup_property_ply (pPly, &vert_props[9]);
		  has_texture_coords = 1;
		}
		if (equal_strings ("t", prop->name)) {
		  setup_property_ply (pPly, &vert_props[10]);
		  has_texture_coords = 1;
		}
		//k++;
      }

      vert_other = get_other_properties_ply (pPly, 
					     offsetof(Vertex,other_props));

      // grab all the vertex elements 
      for (j = 0; j < elem_count; j++) {

		//adv check for doubles

		m_pVertexList[actualVertCount] = (Vertex *) malloc (sizeof (Vertex)); //adv make room for a vertex
		m_pVertexList[actualVertCount]->fr = 1; //check to see if this is in use adv- maybe by removeing it in plyMesh.h ?
		m_pVertexList[actualVertCount]->fg = 1;
		m_pVertexList[actualVertCount]->fb = 1;
		m_pVertexList[actualVertCount]->fb = 0; //adv added because flowply uses a too-- i forget which is transparent and which opaque?

		//adv this was added on 6/1 from flowply	
		// Initialize flags and counts of vertex.
		m_pVertexList[actualVertCount]->valence = 0;
		m_pVertexList[actualVertCount]->marked = 0;
		m_pVertexList[actualVertCount]->max_dtime = 0;
		m_pVertexList[actualVertCount]->boundary_vertex = 0;
		m_pVertexList[actualVertCount]->tx = 0.0;
		m_pVertexList[actualVertCount]->ty = 0.0;
		m_pVertexList[actualVertCount]->tz = 0.0;
		m_pVertexList[actualVertCount]->value[0] = 0.0;
		m_pVertexList[actualVertCount]->value[1] = 0.0;
		m_pVertexList[actualVertCount]->vtx = 0.0;//adv added 6/10
		m_pVertexList[actualVertCount]->vty = 0.0;
		m_pVertexList[actualVertCount]->vtz = 0.0;

		get_element_ply (pPly, (void *) m_pVertexList[actualVertCount]); //adv put the vertex's info in there

		bool doubleVert = false;
		int c=0;
		while(c<actualVertCount && !doubleVert)//doubleVert==false
		{
			if(m_pVertexList[actualVertCount]->fx == m_pVertexList[c]->fx 
				&& m_pVertexList[actualVertCount]->fy == m_pVertexList[c]->fy
				&& m_pVertexList[actualVertCount]->fz == m_pVertexList[c]->fz)
			{
					doubleVert = true;
					double_vertex_list[j] = c; //set it equal to the spot where that vertex was first
			}

			c++;
		}
		//if it is not a double
		if(!doubleVert) //adv this is taken away just to test if it fins doubles?
			actualVertCount++;	

      }
	  m_iNumVertices = actualVertCount; 
    } //adv ends vertex if and next this reads the faces
    else if (equal_strings ("face", elem_name)) 
	{

      // create a list to hold all the face elements 
      m_pFaceList = (Face **) malloc (sizeof (Face *) * elem_count);
      m_iNumFaces = elem_count;

      // set up for getting face elements 

      setup_property_ply (pPly, &face_props[0]);
      face_other = get_other_properties_ply (pPly, 
					     offsetof(Face,other_props));

      // grab all the face elements 
      for (j = 0; j < elem_count; j++) {
        m_pFaceList[j] = (Face *) malloc (sizeof (Face));
        get_element_ply (pPly, (void *) m_pFaceList[j]);
		if(double_vertex_list!=NULL)
		{
			for(int c=0; c<m_pFaceList[j]->ucNumVerts; c++) //for each vertex of the face  
			{
				if(double_vertex_list[ m_pFaceList[j]->pi_verts[c] ] != -777)//if there is a double in this spot
				{
					m_pFaceList[j]->pi_verts[c] = double_vertex_list[ m_pFaceList[j]->pi_verts[c]]; 
					
			//		bunHits++; //adv this is a temp test thing and can be removed onece i know this is working
				}
			}
		}
      }
    }
    else
      get_other_element_ply (pPly);
  }//end big for loop

  close_ply (pPly);
  free_ply (pPly);

  fclose(fp);
}


//adv create a whole new read ply mesh ... to try to clean as we go (keep old one just incase)
//Class functions
void CPlyMesh::ReadPlyMeshOld(char *szFileName)
{
  unsigned int elem_count;
  char *elem_name;
  PlyFile *pPly;
//  PlyOtherProp *vert_other, *face_other;

  int i,k;	//GJB added k
  unsigned int j;	//GJB made j unsigned int
//  int per_vertex_color;
//  int has_normals;

  FILE *fp = fopen(szFileName, "r");
  pPly  = read_ply (fp);

  for (i = 0; i < pPly->num_elem_types; i++) {

    // prepare to read the i'th list of elements 
    elem_name = setup_element_read_ply (pPly, i, (int *) &elem_count);

    if (equal_strings ("vertex", elem_name)) {

      // create a vertex list to hold all the vertices 
      m_pVertexList = (Vertex **) malloc (sizeof (Vertex *) * elem_count);
      m_iNumVertices = elem_count;
bunHits=m_iNumVertices;
      // set up for getting vertex elements 

      setup_property_ply (pPly, &vert_props[0]);
      setup_property_ply (pPly, &vert_props[1]);
      setup_property_ply (pPly, &vert_props[2]);

      for (k = 0; k < pPly->elems[i]->nprops; k++) {
		PlyProperty *prop;
		prop = pPly->elems[i]->props[k];

		if (equal_strings ("r", prop->name)) {
		  setup_property_ply (pPly, &vert_props[3]);
		  per_vertex_color = 1;
		}
		if (equal_strings ("g", prop->name)) {
		  setup_property_ply (pPly, &vert_props[4]);
		  per_vertex_color = 1;
		}
		if (equal_strings ("b", prop->name)) {
		  setup_property_ply (pPly, &vert_props[5]);
		  per_vertex_color = 1;
		}
		if (equal_strings ("nx", prop->name)) {
		  setup_property_ply (pPly, &vert_props[6]);
		  has_normals = 1;
		}
		if (equal_strings ("ny", prop->name)) {
		  setup_property_ply (pPly, &vert_props[7]);
		  has_normals = 1;
		}
		if (equal_strings ("nz", prop->name)) {
		  setup_property_ply (pPly, &vert_props[8]);
		  has_normals = 1;
		}
		if (equal_strings ("s", prop->name)) {
		  setup_property_ply (pPly, &vert_props[9]);
		  has_texture_coords = 1;
		}
		if (equal_strings ("t", prop->name)) {
		  setup_property_ply (pPly, &vert_props[10]);
		  has_texture_coords = 1;
		}
		//k++;
      }

      vert_other = get_other_properties_ply (pPly, 
					     offsetof(Vertex,other_props));

      // grab all the vertex elements 
      for (j = 0; j < elem_count; j++) {
        m_pVertexList[j] = (Vertex *) malloc (sizeof (Vertex));
		m_pVertexList[j]->fr = 1;
		m_pVertexList[j]->fg = 1;
		m_pVertexList[j]->fb = 1;
        get_element_ply (pPly, (void *) m_pVertexList[j]);

/***** HQD: Customize mesh modification *******/
		double newx, newz;
		//if (m_pVertexList[j]->fy > 7.0) {
		//	m_pVertexList[j]->fy -= 10.0;
		//}

		//if (m_pVertexList[j]->fy > 0.35) {
			//m_pVertexList[j]->fy += 1.3;
			//m_pVertexList[j]->fy -= 1.3;
		//}

		/*if (m_pVertexList[j]->fy > 0.1) {
			newx = 0.5*m_pVertexList[j]->fx +
				0.866*m_pVertexList[j]->fz;
			newz = -0.866*m_pVertexList[j]->fx +
				0.5*m_pVertexList[j]->fz;
			m_pVertexList[j]->fx = newx;
			m_pVertexList[j]->fz = newz; 
		}*/

		/*if ((m_pVertexList[j]->fy < -0.4) &&
			(m_pVertexList[j]->fy > -1.0) &&
			(m_pVertexList[j]->fz > -0.3) &&
			(m_pVertexList[j]->fz < 0.3)) {

			m_pVertexList[j]->fx = 0.0;
			m_pVertexList[j]->fy = -0.7;
			m_pVertexList[j]->fz = 0.0;
		}*/

		// Cutting Buddha in half
		/* //if (m_pVertexList[j]->fy < 0.0) {
		if (m_pVertexList[j]->fy > -0.3) {
			m_pVertexList[j]->fx = 0.0;
			m_pVertexList[j]->fy = -0.3;
			m_pVertexList[j]->fz = 0.0;
		} */
      }
    }
    else if (equal_strings ("face", elem_name)) {

      // create a list to hold all the face elements 
      m_pFaceList = (Face **) malloc (sizeof (Face *) * elem_count);
      m_iNumFaces = elem_count;

      // set up for getting face elements 

      setup_property_ply (pPly, &face_props[0]);
      face_other = get_other_properties_ply (pPly, 
					     offsetof(Face,other_props));

      // grab all the face elements 
      for (j = 0; j < elem_count; j++) {
        m_pFaceList[j] = (Face *) malloc (sizeof (Face));
        get_element_ply (pPly, (void *) m_pFaceList[j]);
      }
    }
    else
      get_other_element_ply (pPly);
  }

  close_ply (pPly);
  free_ply (pPly);

  fclose(fp);




// Triangulation pass:
  // Converts all polys with various #s of verts to triangles.
  // BUT: HAS ERROR! Use STL and dynamically growing vectors to fix it before using this function!
/*
  unsigned long ifaceOld;
  int l;
	Face *face;
	int *verts;
	long new_faces, first_vertex, last_vertex;

	new_faces = m_iNumFaces;
	for (ifaceOld=0; ifaceOld<m_iNumFaces; ifaceOld++) {
		face = m_pFaceList[ifaceOld];
		//if( m_pFaceList[0]->ucNumVerts == 16 ) {
		if( ifaceOld >=48 ) {
			Sleep(1);
		}
		if (face->ucNumVerts>3) {
		verts = face->pi_verts;
			m_pVertexList[m_iNumVertices] = (Vertex *)malloc(sizeof(Vertex));
			m_pVertexList[m_iNumVertices]->fx = 0.0;
			m_pVertexList[m_iNumVertices]->fy = 0.0;
			m_pVertexList[m_iNumVertices]->fz = 0.0;
			for (j=0; j<face->ucNumVerts; j++){ 
				m_pVertexList[m_iNumVertices]->fx += m_pVertexList[verts[j]]->fx;
				m_pVertexList[m_iNumVertices]->fy += m_pVertexList[verts[j]]->fy;
				m_pVertexList[m_iNumVertices]->fz += m_pVertexList[verts[j]]->fz;
			}
			m_pVertexList[m_iNumVertices]->fx /= face->ucNumVerts;
			m_pVertexList[m_iNumVertices]->fy /= face->ucNumVerts;
			m_pVertexList[m_iNumVertices]->fz /= face->ucNumVerts;
			//face->ucNumVerts++;
			m_iNumVertices++;

			for (l=0; l<face->ucNumVerts-1; l++){
				m_pFaceList[new_faces+l] = (Face *)malloc(sizeof(Face));	// ERROR! Can't just allocate more slots on this array!
				m_pFaceList[new_faces+l]->pi_verts = (int *)malloc(sizeof(Vertex) * 3);
				m_pFaceList[new_faces+l]->pi_verts[0] = face->pi_verts[l];
				m_pFaceList[new_faces+l]->pi_verts[1] = face->pi_verts[l+1];
				m_pFaceList[new_faces+l]->pi_verts[2] = m_iNumVertices-1;
				m_pFaceList[new_faces+l]->ucNumVerts = 3;
			}
			new_faces += face->ucNumVerts - 1;
			first_vertex = face->pi_verts[0];
			last_vertex = face->pi_verts[face->ucNumVerts -1];
			free(m_pFaceList[ifaceOld]->pi_verts);
			m_pFaceList[ifaceOld]->pi_verts = NULL;
			m_pFaceList[ifaceOld]->pi_verts = (int *)malloc(sizeof(Vertex)*3);
			m_pFaceList[ifaceOld]->pi_verts[0] = last_vertex;
			m_pFaceList[ifaceOld]->pi_verts[1] = first_vertex;
			m_pFaceList[ifaceOld]->pi_verts[2] = m_iNumVertices-1;
			m_pFaceList[ifaceOld]->ucNumVerts = 3;
		}
	}
	m_iNumFaces = new_faces;
*/

}

void CPlyMesh::WritePlyMesh(char *szFileName)
{
  int i;
  PlyFile *ply;
  int file_type = PLY_ASCII;
  FILE* fp;
  char* elem_names[2] = {"vertex","face"};

  fp = fopen (szFileName, "w");

  /*** Write out the transformed PLY object ***/

  ply = write_ply (fp, 2, elem_names, file_type);

  /* describe what properties go into the vertex elements */

  describe_element_ply (ply, "vertex", m_iNumVertices);
  describe_property_ply (ply, &vert_props[0]);
  describe_property_ply (ply, &vert_props[1]);
  describe_property_ply (ply, &vert_props[2]);
  if (per_vertex_color) {
	describe_property_ply (ply, &vert_props[3]);
	describe_property_ply (ply, &vert_props[4]);
	describe_property_ply (ply, &vert_props[5]);
  }
  if (has_normals) {
	describe_property_ply (ply, &vert_props[6]);
	describe_property_ply (ply, &vert_props[7]); 
	describe_property_ply (ply, &vert_props[8]); 
  }
  if (has_texture_coords) {
	describe_property_ply (ply, &vert_props[9]);
	describe_property_ply (ply, &vert_props[10]); 
  }
  describe_other_properties_ply (ply, vert_other, offsetof(Vertex,other_props));

  describe_element_ply (ply, "face", m_iNumFaces);
  describe_property_ply (ply, &face_props[0]);
  describe_other_properties_ply (ply, face_other, offsetof(Face,other_props));

  append_comment_ply (ply, "created by viewply");

  header_complete_ply (ply);

  // set up and write the vertex elements 
  put_element_setup_ply (ply, "vertex");
   
  for (i = 0; i < m_iNumVertices; i++) {
	  put_element_ply (ply, (void *) (m_pVertexList[i])); //adv here is an example of plyMesh using ply.c
  }

  // set up and write the vertex elements 

  put_element_setup_ply (ply, "face");

  for (i = 0; i < m_iNumFaces; i++) {
  	  put_element_ply (ply, (void *) (m_pFaceList[i]));
  }

  close_ply (ply);
  free_ply (ply);
}

//added by adv on 6/1 from flowply
//adv vlist is verticies and tlist is faces? .. if so i change them to: m_pVertexList and m_pFaceList
//verts changes to pi_verts
//replace nverts with ucNumVerts -- wait nverts is also declared again, so it might not be right; 
//it depends if it's all verticies of just acociated with a face (if all: m_iNumVertices)
void CPlyMesh::collect_adj_info ()
{
  int vindex, new_v, i, j, k;
  int adj_v_cnt = 0, duplicate;
  sFace *t; //adv was Face in flowPlay

  // Collect adjacent triangle information first since it is 
  // later used in collecting adjacent vertices.
  for (i = 0; i < m_iNumFaces; i++) { //adv was nfaces in flowply
    // Add triangle to adjacency list of vertex.
    t = m_pFaceList[i];
    if (m_pVertexList[t->pi_verts[0]]->valence >= 20) {
      printf ("Number of adjacent triangles (20) exceeded!\n");
      continue;
    }
    m_pVertexList[t->pi_verts[0]]->adj_tris[m_pVertexList[t->pi_verts[0]]->valence++] = t; //adv add each triangle to the face list of each of its verticies
    m_pVertexList[t->pi_verts[1]]->adj_tris[m_pVertexList[t->pi_verts[1]]->valence++] = t;
    m_pVertexList[t->pi_verts[2]]->adj_tris[m_pVertexList[t->pi_verts[2]]->valence++] = t; 
  }

  // Collect adjacent vertex information using adj. triangle info. 
  for (vindex = 0; vindex < m_iNumVertices; vindex++) {
    adj_v_cnt = 0;

    for (j=0; j<m_pVertexList[vindex]->valence; j++) { //adv num of triangeles around vertex (or of lines- equal)
      for (i=0; i<3; i++) {
	new_v = m_pVertexList[vindex]->adj_tris[j]->pi_verts[i];
	
	// Check if candidate vertex is vindex.
	if (new_v == vindex) continue; //this skips the rest, and goes to the beginning of the loop (with the index++)
	
	// Check if candidate vertex is already in the list of adj_v.
	duplicate = 0;
	for (k=0; k<adj_v_cnt; k++) {
	  if (m_pVertexList[vindex]->adj_verts[k] == new_v) {
	    duplicate = 1;
	    break;
	  }
	}
	if (duplicate == 1) continue;
	//if (adj_v[k-1] == new_v) continue;
	if (adj_v_cnt == 21) { //adv num of adjacent verticies has a max of 20 ... should be fine
	  printf ("Number of neighboring vertices (21) exceeded!\n");
	  break;
	}
	m_pVertexList[vindex]->adj_verts[adj_v_cnt] = new_v;      //adv add vertex
	m_pVertexList[vindex]->adj_verts_w[adj_v_cnt] = 0.0;	//adv if diffusion- keep, if propagation-get rid of
	adj_v_cnt++;
      }
      if (adj_v_cnt == 20) break;
    }
    if (adj_v_cnt > m_pVertexList[vindex]->valence) //adv we store valence as number of adjacent faces, so if it's at a border, we may need this
      // vertex valence is greater than triangle valence, 
      // so vertex is a boundary vertex.
      m_pVertexList[vindex]->boundary_vertex = 1;
  }
  
}

//added by adv 6/1 from flowply
//adv I think x, y, and z, become fx, fy, and fz
/******************************************************************************
Assign color to vertices to track flow field.
******************************************************************************/
void CPlyMesh::boundary_corr_init ()
{
  int i;
  double start_fudge_factor = 0.001;
  float color;

  // Seed triangle color at time 0.0.
  for (i = 0; i < m_iNumVertices; i++) {//adv was nverts

	  //we need to test if the point is the start point
	  bool isStart = false;
	  int findS=0;
	  while(findS<maxStart && !isStart)
	  {
		  if ( m_pVertexList[i]->fz == start_times[findS].fz ) //originally we needed a threshhold, now we dont- m_pVertexList[i]->fz < (start_times[findS].fz + thresh) && m_pVertexList[i]->fz > (start_times[findS].fz - thresh)
			  isStart= true;

		  findS++;

	  }

	  bool isEnd = false;
	  int findE=0;
	  while( findE<maxEnd && !isEnd )
	  {
		  if ( m_pVertexList[i]->fz == end_times[findE].fz ) //m_pVertexList[i]->fz < (end_times[findE].fz + thresh) && m_pVertexList[i]->fz > (end_times[findE].fz - thresh)
			  isEnd= true;
		  findE++;

	  }
	if(isStart)
	{
	  //adv recall using scalor field as color-- so no matter where it starts or ends- its 0 to 1
      color = 0.0;
      m_pVertexList[i]->marked = START_BOUNDARY; //adv set as start, where the information is given and will not change 
    }
	//adv same for end
	else if(isEnd)
	{
		color = 1.0;
      m_pVertexList[i]->marked = END_BOUNDARY;
    }
    else {
//adv source and sink values are tested here: instead of 0 and 1 ... tried numbers between them
	  float totalDistanceTimesValue = 0;
	  for(int tot=0; tot<maxStart; tot++)
	  {
		  totalDistanceTimesValue+= (0 * sqrt(pow(m_pVertexList[i]->fx - start_times[tot].fx,2)+pow(m_pVertexList[i]->fy - start_times[tot].fy,2)+pow(m_pVertexList[i]->fz - start_times[tot].fz,2))  ); 
	  }

	  for(int tot=0; tot<maxEnd; tot++)
	  {
		  totalDistanceTimesValue+= (1 * sqrt(pow(m_pVertexList[i]->fx - end_times[tot].fx,2)+pow(m_pVertexList[i]->fy - end_times[tot].fy,2)+pow(m_pVertexList[i]->fz - end_times[tot].fz,2))  ); 
	  }

/*
//adv these were used to test diferent values of the sources and sinks
	  totalDistanceTimesValue += (0 * sqrt(pow(m_pVertexList[i]->fx - start_times[0].fx,2)+pow(m_pVertexList[i]->fy - start_times[0].fy,2)+pow(m_pVertexList[i]->fz - start_times[0].fz,2))  ); 
	  totalDistanceTimesValue += (1 * sqrt(pow(m_pVertexList[i]->fx - end_times[1].fx,2)+pow(m_pVertexList[i]->fy - end_times[1].fy,2)+pow(m_pVertexList[i]->fz - end_times[1].fz,2))  ); 
	  totalDistanceTimesValue += (0 * sqrt(pow(m_pVertexList[i]->fx - start_times[1].fx,2)+pow(m_pVertexList[i]->fy - start_times[1].fy,2)+pow(m_pVertexList[i]->fz - start_times[1].fz,2))  ); 
	  totalDistanceTimesValue+= (.5 * sqrt(pow(m_pVertexList[i]->fx - end_times[0].fx,2)+pow(m_pVertexList[i]->fy - end_times[0].fy,2)+pow(m_pVertexList[i]->fz - end_times[0].fz,2))  ); 
*/	


	   color = 1/totalDistanceTimesValue; //trying this
      m_pVertexList[i]->marked = VALUE_ASSIGNED;

    } 

 
    // Mark and color.
    m_pVertexList[i]->fr = color;
    m_pVertexList[i]->fg = color;
    m_pVertexList[i]->fb = color;
    m_pVertexList[i]->fa = 0.0;
  }
}

//added by adv 6/1 from flowply
/**********************************************************************
Function uses the Desbrun curvature measurement
**********************************************************************/
float CPlyMesh::desbrun ()
{
  int v, i, j, v2_index, cnt = 0;
  sFace *f, *f2, *t2;
  // Allocate data structure to store the triangle indices associated with each vertex.
  double curve_factor, phi, theta;
  double v1[3], v2[3], v3[3], v4[3], v1_cross[3], v4_cross[3];
  double vert_area;

  float *init_colors, r, g, b, total_w, avg_intensity_change;
  avg_intensity_change=0; //adv added this seperately because i was getting na error that it was undefined?

  // Allocate space and initialize array of initial colors.
  init_colors = (float*) calloc (m_iNumVertices, sizeof(float)); //adv was nverts
  for (i = 0; i < m_iNumVertices; i++) { //adv was nverts
    init_colors[i] = m_pVertexList[i]->fg;
  }

  for (v=0; v<m_iNumVertices; v++) {//adv was nverts

    // Skip vertices that are not part of flow, or that are on boundary.
    if (m_pVertexList[v]->marked != VALUE_ASSIGNED) continue;

    cnt++;
    total_w = 0.0;
    vert_area = 0.0;
    r = 0.0; g = 0.0; b = 0.0;

    for (i=0; i<m_pVertexList[v]->valence; i++) {
      f = m_pVertexList[v]->adj_tris[i];
      if (f->pi_verts[0] == v) {
	v2_index = f->pi_verts[1];

	v1[0] = m_pVertexList[f->pi_verts[0]]->fx - m_pVertexList[f->pi_verts[2]]->fx;
	v1[1] = m_pVertexList[f->pi_verts[0]]->fy - m_pVertexList[f->pi_verts[2]]->fy;
	v1[2] = m_pVertexList[f->pi_verts[0]]->fz - m_pVertexList[f->pi_verts[2]]->fz;

	v2[0] = m_pVertexList[f->pi_verts[1]]->fx - m_pVertexList[f->pi_verts[2]]->fx;
	v2[1] = m_pVertexList[f->pi_verts[1]]->fy - m_pVertexList[f->pi_verts[2]]->fy;
	v2[2] = m_pVertexList[f->pi_verts[1]]->fz - m_pVertexList[f->pi_verts[2]]->fz;
	
	/* All triangles in the list have v in common.  Now, find triangle
	   that has 2nd vertex in common. */
	t2 = NULL;
	for (j=0; j<m_pVertexList[v]->valence; j++) {
	  f2 = m_pVertexList[v]->adj_tris[j];
	  if (f2 == f) continue;
	  if ((f2->pi_verts[0] == f->pi_verts[1]) || (f2->pi_verts[1] == f->pi_verts[1]) || (f2->pi_verts[2] == f->pi_verts[1])) {
	    t2 = f2;
	    break;
	  }
	}

	if (t2 == NULL) break;

	// Now, assign v3 and v4.
	assign_v3_v4_new (v, t2, v3, v4);
      }
      
      else if (f->pi_verts[1] == v) {
	v2_index = f->pi_verts[2];

	v1[0] = m_pVertexList[f->pi_verts[1]]->fx - m_pVertexList[f->pi_verts[0]]->fx;
	v1[1] = m_pVertexList[f->pi_verts[1]]->fy - m_pVertexList[f->pi_verts[0]]->fy;
	v1[2] = m_pVertexList[f->pi_verts[1]]->fz - m_pVertexList[f->pi_verts[0]]->fz;

	v2[0] = m_pVertexList[f->pi_verts[2]]->fx - m_pVertexList[f->pi_verts[0]]->fx;
	v2[1] = m_pVertexList[f->pi_verts[2]]->fy - m_pVertexList[f->pi_verts[0]]->fy;
	v2[2] = m_pVertexList[f->pi_verts[2]]->fz - m_pVertexList[f->pi_verts[0]]->fz;

	/* All triangles in the list have v in common.  Now, find triangle
	   that has 2nd vertex in common. */
	t2 = NULL;
	for (j=0; j<m_pVertexList[v]->valence; j++) {
	  f2 = m_pVertexList[v]->adj_tris[j];
	  if (f2 == f) continue;
	  if ((f2->pi_verts[0] == f->pi_verts[2]) || (f2->pi_verts[1] == f->pi_verts[2]) || (f2->pi_verts[2] == f->pi_verts[2])) {
	    t2 = f2;
	    break;
	  }
	}

	if (t2 == NULL) break;

	// Now, assign v3 and v4.
	assign_v3_v4_new (v, t2, v3, v4);
      }
      
      else {
	v2_index = f->pi_verts[0];

	v1[0] = m_pVertexList[f->pi_verts[2]]->fx - m_pVertexList[f->pi_verts[1]]->fx;
	v1[1] = m_pVertexList[f->pi_verts[2]]->fy - m_pVertexList[f->pi_verts[1]]->fy;
	v1[2] = m_pVertexList[f->pi_verts[2]]->fz - m_pVertexList[f->pi_verts[1]]->fz;

	v2[0] = m_pVertexList[f->pi_verts[0]]->fx - m_pVertexList[f->pi_verts[1]]->fx;
	v2[1] = m_pVertexList[f->pi_verts[0]]->fy - m_pVertexList[f->pi_verts[1]]->fy;
	v2[2] = m_pVertexList[f->pi_verts[0]]->fz - m_pVertexList[f->pi_verts[1]]->fz;

	/* All triangles in the list have v in common.  Now, find triangle
	   that has 2nd vertex in common. */
	t2 = NULL;
	for (j=0; j<m_pVertexList[v]->valence; j++) {
	  f2 = m_pVertexList[v]->adj_tris[j];
	  if (f2 == f) continue;
	  if ((f2->pi_verts[0] == f->pi_verts[0]) || (f2->pi_verts[1] == f->pi_verts[0]) || (f2->pi_verts[2] == f->pi_verts[0])) {
	    t2 = f2;
	    break;
	  }
	}
	
	if (t2 == NULL) break;

	// Now, assign v3 and v4.
	assign_v3_v4_new (v, t2, v3, v4);
      }
      
      // Check if v2 is NOT part of flow.
      if (m_pVertexList[v2_index]->marked < VALUE_ASSIGNED) continue;

      // NO NEED to normalize vectors.

      /* Calculate contribution of triangle to the area.  Note
         that area must be calculated before normalization since
         area is calculated using cross product. */
      vert_area += area (v1,v2);
      
      // Normalize all vectors;
      normalize_vec(v1);
      normalize_vec(v2);
      normalize_vec(v3);
      normalize_vec(v4);
      
      // Calculate angles.
      theta = acos(dot(v1,v2)); 
      phi = acos(dot(v4,v3));  

      // Apply to color.  
      // Check if v2 is boundary vertex (marked as CORR_BOUNDARY).  Handle specially.
      // Make assumption that boundary is 0 valued if vertex intensity value is
      // closer to 0.  Otherwise, boundary is 1 valued.
      if (m_pVertexList[v2_index]->marked == CORR_BOUNDARY) {
	if (init_colors[v] <= 0.5)
	  g += ((1.0/tan(theta)) + (1.0/tan(phi))) * -1.0 * init_colors[v]; 
	else g += ((1.0/tan(theta)) + (1.0/tan(phi))) * (1.0 - init_colors[v]); 
      }
      else g += ((1.0/tan(theta)) + (1.0/tan(phi))) * (init_colors[v2_index] - init_colors[v]); 

      total_w += (1.0/tan(theta)) + (1.0/tan(phi));

      // Apply cot in form of dot and cross-prods to edge vector. edge = v1-v2.
      /* cross(v1,v2,v1_cross);
      cross(v2,v1_cross,v1_cross);
      cross(v4,v3,v4_cross);
      cross(v3,v4_cross,v4_cross);

      curve_factor = (sqrt(dot(v1_cross,v1_cross))/sqrt(dot(v2,v2)))*(dot(v1,v2)/dot(v1,v1_cross)) + 
      	(sqrt(dot(v4_cross,v4_cross))/sqrt(dot(v3,v3)))*(dot(v4,v3)/dot(v4,v4_cross));

      // Apply curve factor to color
      g += curve_factor * (init_colors[v2_index] - init_colors[v]); */
    }

    if (t2 == NULL) continue;

    //m_pVertexList[v]->g += (1.0/(2.0 * vert_area)) * g;
    m_pVertexList[v]->fg += g/total_w;
    m_pVertexList[v]->fr = m_pVertexList[v]->fg;
    m_pVertexList[v]->fb = m_pVertexList[v]->fg; 

    avg_intensity_change += g/total_w;
  }

  free (init_colors);

  if (avg_intensity_change < 0.0) 
    avg_intensity_change /= -1.0 * cnt;
  else avg_intensity_change /= cnt;
  return avg_intensity_change;

}

//added by adv on 6/1 for use by the method right before this
// Function assigns v3 and v4 for Desbrun smoothing.
void CPlyMesh::assign_v3_v4_new (int v, sFace* t2, double* v3, double* v4)
{
  if (t2->pi_verts[0] == v) {
    v3[0] = m_pVertexList[t2->pi_verts[2]]->fx - m_pVertexList[t2->pi_verts[1]]->fx;
    v3[1] = m_pVertexList[t2->pi_verts[2]]->fy - m_pVertexList[t2->pi_verts[1]]->fy;
    v3[2] = m_pVertexList[t2->pi_verts[2]]->fz - m_pVertexList[t2->pi_verts[1]]->fz;
    
    v4[0] = m_pVertexList[t2->pi_verts[0]]->fx - m_pVertexList[t2->pi_verts[1]]->fx;
    v4[1] = m_pVertexList[t2->pi_verts[0]]->fy - m_pVertexList[t2->pi_verts[1]]->fy;
    v4[2] = m_pVertexList[t2->pi_verts[0]]->fz - m_pVertexList[t2->pi_verts[1]]->fz;
  }
  else if (t2->pi_verts[1] == v) {
    v3[0] = m_pVertexList[t2->pi_verts[0]]->fx - m_pVertexList[t2->pi_verts[2]]->fx;
    v3[1] = m_pVertexList[t2->pi_verts[0]]->fy - m_pVertexList[t2->pi_verts[2]]->fy;
    v3[2] = m_pVertexList[t2->pi_verts[0]]->fz - m_pVertexList[t2->pi_verts[2]]->fz;
    
    v4[0] = m_pVertexList[t2->pi_verts[1]]->fx - m_pVertexList[t2->pi_verts[2]]->fx;
    v4[1] = m_pVertexList[t2->pi_verts[1]]->fy - m_pVertexList[t2->pi_verts[2]]->fy;
    v4[2] = m_pVertexList[t2->pi_verts[1]]->fz - m_pVertexList[t2->pi_verts[2]]->fz;
  }
  else {
    v3[0] = m_pVertexList[t2->pi_verts[1]]->fx - m_pVertexList[t2->pi_verts[0]]->fx;
    v3[1] = m_pVertexList[t2->pi_verts[1]]->fy - m_pVertexList[t2->pi_verts[0]]->fy;
    v3[2] = m_pVertexList[t2->pi_verts[1]]->fz - m_pVertexList[t2->pi_verts[0]]->fz;
    
    v4[0] = m_pVertexList[t2->pi_verts[2]]->fx - m_pVertexList[t2->pi_verts[0]]->fx;
    v4[1] = m_pVertexList[t2->pi_verts[2]]->fy - m_pVertexList[t2->pi_verts[0]]->fy;
    v4[2] = m_pVertexList[t2->pi_verts[2]]->fz - m_pVertexList[t2->pi_verts[0]]->fz;
  }
}

//these are next two needed for field; added by adv on 6/1 from flowply
/******************************************************************************
  Routines for generating the tangent field on the surface pointing in the
  gradient direction w.r.t. time.
******************************************************************************/
//adv so we would need to move this method to the other program
void CPlyMesh::generate_normal_field ()
{
  int i, j, cnt;
  double surfnorm[3];
  sFace* adj_tlist[20];  // List of adjacent triangles.

  for (i = 0; i < m_iNumVertices; i++) {//adv was nverts
    
    // Skip vertices that are not part of flow.
    if (m_pVertexList[i]->marked == VERTEX_PROCESSED) continue;
    
    cnt = 0;
    // Use ALL adjacent triangles, not just the ones
    // that are part of the flow.
    for (j=0; j<m_pVertexList[i]->valence; j++) {
      adj_tlist[cnt++] = m_pVertexList[i]->adj_tris[j];
    }

    // Compute weighted average normal.
    average_normal(adj_tlist, cnt, m_pVertexList, i, surfnorm);  // average_norm returns unit vector.
    m_pVertexList[i]->fnx = surfnorm[0];
    m_pVertexList[i]->fny = surfnorm[1];
    m_pVertexList[i]->fnz = surfnorm[2];
  } 
}

void CPlyMesh::generate_weighted_tangent_field ()
//adv need to move this method
{
  int i, j, k;
  double total_t[3], total_area, t[3], tri_area, n[3], proj, total_c[3];
  sFace* adj_f;

  for (i = 0; i < m_iNumVertices; i++) {//was nverts
    
    // Skip vertices that are not part of flow.
    if (m_pVertexList[i]->marked == VERTEX_PROCESSED) continue;
    
    // Compute gradient by averaging gradient w.r.t all TRIANGLES in 
    // valence, using the barycenter of the neighboring triangles.
    total_t[0] = 0.0; total_t[1] = 0.0; total_t[2] = 0.0;
    total_c[0] = 0.0; total_c[1] = 0.0; total_c[2] = 0.0;
    total_area = 0.0;
    for (j=0; j<m_pVertexList[i]->valence; j++) {
      adj_f = m_pVertexList[i]->adj_tris[j];

      // Check to see if all vertices of face is in flow.
      if ((m_pVertexList[adj_f->pi_verts[0]]->marked < VALUE_ASSIGNED) || 
	  (m_pVertexList[adj_f->pi_verts[1]]->marked < VALUE_ASSIGNED) || 
	  (m_pVertexList[adj_f->pi_verts[2]]->marked < VALUE_ASSIGNED)) continue;

      triangle_grad(adj_f, i, t, m_pVertexList[adj_f->pi_verts[0]]->fr, m_pVertexList[adj_f->pi_verts[1]]->fr, m_pVertexList[adj_f->pi_verts[2]]->fr);

      tri_area = area (adj_f);
      total_area += tri_area;
      for (k=0; k<3; k++) total_t[k] += tri_area * t[k];  // Use weighted average.
      for (k=0; k<3; k++) total_c[k] += t[k];  // t is already normalized, so sum.
    }

    // Divide by total weight.
    for (k=0; k<3; k++) total_t[k] /= total_area;

    // Project tangent vector onto tangent plane.
    n[0] = m_pVertexList[i]->fnx; n[1] = m_pVertexList[i]->fny; n[2] = m_pVertexList[i]->fnz; 
    proj = dot (n, total_t);
    for (k=0; k<3; k++) total_t[k] -= proj * n[k]; 

    // Assign magnitude of total_c as confidence of tangent. 
    // Small values mean that tangent is may be near a sink/source point.
    proj = dot(n, total_c);
    for (k=0; k<3; k++) total_c[k] -= proj * n[k]; 
    //m_pVertexList[i]->tconf = sqrt (dot(total_c, total_c));
    m_pVertexList[i]->tconf = sqrt(dot(total_t, total_t));

    // Normalize the gradient.
    normalize_vec(total_t);
    
    m_pVertexList[i]->tx = total_t[0];		
    m_pVertexList[i]->ty = total_t[1];		
    m_pVertexList[i]->tz = total_t[2]; 
  } 
}

//added by adv on 6/1 from flowply

// Compute average normal of a ring of triangles.  Assumes all 
// triangles are referenced by tris and all relevant vertices
// are referenced by verts.
void CPlyMesh::average_normal (sFace** tris, int num_tris, sVertex** verts, int v, double* norm)
{
  int i;
  double v1[3], v2[3], tnorm[3], tri_area;

  norm[0] = 0.0; norm[1] = 0.0; norm[2] = 0.0;
  
  for (i=0; i<num_tris; i++) {

    // Find which vertex of triangle corresponds to target vertex.
    // Note that order of v1, v2 is defined to follow right hand
    // rule.  ply is left hand rule.
    if (tris[i]->pi_verts[0] == v) {
      v1[0] = verts[tris[i]->pi_verts[2]]->fx - verts[v]->fx;
      v1[1] = verts[tris[i]->pi_verts[2]]->fy - verts[v]->fy;
      v1[2] = verts[tris[i]->pi_verts[2]]->fz - verts[v]->fz;
      v2[0] = verts[tris[i]->pi_verts[1]]->fx - verts[v]->fx;
      v2[1] = verts[tris[i]->pi_verts[1]]->fy - verts[v]->fy;
      v2[2] = verts[tris[i]->pi_verts[1]]->fz - verts[v]->fz;
    }
    else if (tris[i]->pi_verts[1] == v) {
      v1[0] = verts[tris[i]->pi_verts[0]]->fx - verts[v]->fx;
      v1[1] = verts[tris[i]->pi_verts[0]]->fy - verts[v]->fy;
      v1[2] = verts[tris[i]->pi_verts[0]]->fz - verts[v]->fz;
      v2[0] = verts[tris[i]->pi_verts[2]]->fx - verts[v]->fx;
      v2[1] = verts[tris[i]->pi_verts[2]]->fy - verts[v]->fy;
      v2[2] = verts[tris[i]->pi_verts[2]]->fz - verts[v]->fz;
    }
    else if (tris[i]->pi_verts[2] == v) {
      v1[0] = verts[tris[i]->pi_verts[1]]->fx - verts[v]->fx;
      v1[1] = verts[tris[i]->pi_verts[1]]->fy - verts[v]->fy;
      v1[2] = verts[tris[i]->pi_verts[1]]->fz - verts[v]->fz;
      v2[0] = verts[tris[i]->pi_verts[0]]->fx - verts[v]->fx;
      v2[1] = verts[tris[i]->pi_verts[0]]->fy - verts[v]->fy;
      v2[2] = verts[tris[i]->pi_verts[0]]->fz - verts[v]->fz;
    }
    
    cross (v1, v2, tnorm);
    tri_area = area (tris[i]);

    norm[0] += tnorm[0] * tri_area;
    norm[1] += tnorm[1] * tri_area;
    norm[2] += tnorm[2] * tri_area;    
  }

  normalize_vec(norm);
}

//added by adv on 6/2/05 from flowply

void CPlyMesh::triangle_grad (sFace* tri, int v, double* g, double val0, double val1, double val2)
{
  double v1[3], v2[3], f0, f1, f2, f1ortho;
  double proj, len, v1ortho[3], df_a, df_b;
  int i;

  if (v == tri->pi_verts[0]) {
    v1[0] = m_pVertexList[tri->pi_verts[2]]->fx - m_pVertexList[v]->fx;
    v1[1] = m_pVertexList[tri->pi_verts[2]]->fy - m_pVertexList[v]->fy;
    v1[2] = m_pVertexList[tri->pi_verts[2]]->fz - m_pVertexList[v]->fz;
    v2[0] = m_pVertexList[tri->pi_verts[1]]->fx - m_pVertexList[v]->fx;
    v2[1] = m_pVertexList[tri->pi_verts[1]]->fy - m_pVertexList[v]->fy;
    v2[2] = m_pVertexList[tri->pi_verts[1]]->fz - m_pVertexList[v]->fz;
    f0 = val0;
    f1 = val2;
    f2 = val1;
  }
  else if (v == tri->pi_verts[1]) {
    v1[0] = m_pVertexList[tri->pi_verts[0]]->fx - m_pVertexList[v]->fx;
    v1[1] = m_pVertexList[tri->pi_verts[0]]->fy - m_pVertexList[v]->fy;
    v1[2] = m_pVertexList[tri->pi_verts[0]]->fz - m_pVertexList[v]->fz;
    v2[0] = m_pVertexList[tri->pi_verts[2]]->fx - m_pVertexList[v]->fx;
    v2[1] = m_pVertexList[tri->pi_verts[2]]->fy - m_pVertexList[v]->fy;
    v2[2] = m_pVertexList[tri->pi_verts[2]]->fz - m_pVertexList[v]->fz;
    f0 = val1;
    f1 = val0;
    f2 = val2;
  }
  else if (v == tri->pi_verts[2]) {
    v1[0] = m_pVertexList[tri->pi_verts[1]]->fx - m_pVertexList[v]->fx;
    v1[1] = m_pVertexList[tri->pi_verts[1]]->fy - m_pVertexList[v]->fy;
    v1[2] = m_pVertexList[tri->pi_verts[1]]->fz - m_pVertexList[v]->fz;
    v2[0] = m_pVertexList[tri->pi_verts[0]]->fx - m_pVertexList[v]->fx;
    v2[1] = m_pVertexList[tri->pi_verts[0]]->fy - m_pVertexList[v]->fy;
    v2[2] = m_pVertexList[tri->pi_verts[0]]->fz - m_pVertexList[v]->fz;
    f0 = val2;
    f1 = val1;
    f2 = val0;
  }

  // Calculate value of f1 along vector orthogonal
  // to v2 ... so, assign f1ortho.
  proj = dot (v1, v2);
  len = dot (v2, v2);
  // Do NOT use (f1-f0) since f1ortho would then
  // be the difference along v1ortho.  Would need to
  // add back f0 to get f1ortho anyway.
  //f1ortho = (f1 - f0) - (proj/len)*(f2 - f0);
  f1ortho = f1 - (proj/len)*(f2 - f0);  

  // Obtain orthogonal unit vectors along v2 and v1 (ortho to v2).
  for (i=0; i<3; i++) { 
    v1ortho[i] = v1[i] - (proj/len) * v2[i];
  }

  // Calculate tangent.
  df_a = (f2 - f0) / sqrt (dot (v2, v2));
  df_b = (f1ortho - f0) / sqrt (dot (v1ortho, v1ortho));
  normalize_vec (v1ortho);
  normalize_vec (v2);
  for (i=0; i<3; i++) {
    g[i] = df_a * v2[i] + df_b * v1ortho[i];
  } 

  normalize_vec (g);
}

//end methods added by adv 


void CPlyMesh::WriteIVMesh(char *szFileName, bool bWriteBinaryFile)
{
  assert(m_pVertexList != NULL);
  assert(m_pFaceList != NULL);

  FILE *fp = fopen(szFileName, "w");
  unsigned int i;
  int j;
  int has_normals = 0;
  int per_vertex_color = 0;

  fprintf(fp,"#Inventor V2.1 ascii\n");
  fprintf(fp,"\n");

  fprintf(fp,"Separator {\n");
  fprintf(fp,"\n");

  /* write out the coordinates */

  fprintf(fp,"Coordinate3 {\n");
  fprintf(fp,"  point [\n");

  for (i = 0; i < m_iNumVertices; i++)
    fprintf(fp,"    %g %g %g,\n", m_pVertexList[i]->fx, m_pVertexList[i]->fy, m_pVertexList[i]->fz);

  fprintf(fp,"  ]\n");
  fprintf(fp,"}\n");
  fprintf(fp,"\n");

  /* if we have them, write surface normals */

  if (has_normals) {
    fprintf(fp,"Normal {\n");
    fprintf(fp,"  vector [\n");

    for (i = 0; i < m_iNumVertices; i++)
      fprintf(fp,"    %g %g %g,\n", m_pVertexList[i]->fnx, m_pVertexList[i]->fny, m_pVertexList[i]->fnz);

    fprintf(fp,"  ]\n");
    fprintf(fp,"}\n");
    fprintf(fp,"\n");
  }

  /* write out the vertex colors */

  fprintf(fp,"Material {\n");
  fprintf(fp,"  diffuseColor [\n");
  if (per_vertex_color) {
    for (i = 0; i < m_iNumVertices; i++)
      fprintf(fp,"    %g %g %g,\n", m_pVertexList[i]->fr, m_pVertexList[i]->fg, m_pVertexList[i]->fb);
  }
  else
    fprintf(fp,"    1 1 1\n");
  fprintf(fp,"  ]\n");
  fprintf(fp,"}\n");
  fprintf(fp,"\n");

  fprintf(fp,"\n");
  fprintf(fp,"MaterialBinding { value PER_VERTEX_INDEXED }\n");
  fprintf(fp,"\n");

  /* write the faces */

  fprintf(fp,"IndexedFaceSet {\n");
  fprintf(fp,"  coordIndex [\n");

  for (i = 0; i < m_iNumFaces; i++) {
    fprintf(fp,"   ");
    for (j = m_pFaceList[i]->ucNumVerts - 1; j >= 0; j--)
      fprintf(fp," %d,", m_pFaceList[i]->pi_verts[j]);
    fprintf(fp," -1,\n");
  }

  fprintf(fp,"  ]\n");

  fprintf(fp,"  materialIndex [\n");

  for (i = 0; i < m_iNumFaces; i++) {
    fprintf(fp,"   ");
    for (j = m_pFaceList[i]->ucNumVerts - 1; j >= 0; j--)
      if (per_vertex_color) {
	fprintf(fp," %d,", m_pFaceList[i]->pi_verts[j]);
      }
      else
	fprintf(fp," 0,");
    fprintf(fp," -1,\n");
  }

  fprintf(fp,"  ]\n");
  fprintf(fp,"}\n");
  fprintf(fp,"\n");

  /* end separator */

  fprintf(fp,"}\n");
  fprintf(fp,"\n");
  fclose(fp);
}


